// -*- mode: Rust -*-

// AUTOGENERATED BY glean_parser.  DO NOT EDIT.

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

use glean::private::PingType;
use once_cell::sync::Lazy;

#[allow(non_upper_case_globals)]
/// Only on iOS and Android.
/// Data for VPN sessions, as recorded from the Android daemon and
/// iOS Network Extension. This ping will record start/end datestamp,
/// session-based metrics, etc.
pub static daemonsession: Lazy<PingType> = Lazy::new(|| {
    PingType::new(
        "daemonsession",
        true,
        false,
        vec!["daemon_end".into(), "daemon_flush".into(), "daemon_start".into(), "daemon_timer".into()],
    )
});

#[allow(non_upper_case_globals)]
/// A simple ping to send glean events generated by the Mozilla Cuddlefish apps.
pub static main: Lazy<PingType> = Lazy::new(|| {
    PingType::new(
        "main",
        true,
        false,
        vec![],
    )
});

#[allow(non_upper_case_globals)]
/// Data for one VPN session, defined as a user turning on and eventually
/// turning off the VPN in the app. This ping will record start/end datestamp,
/// session-based metrics, etc.
pub static vpnsession: Lazy<PingType> = Lazy::new(|| {
    PingType::new(
        "vpnsession",
        true,
        false,
        vec!["end".into(), "flush".into(), "start".into(), "timer".into()],
    )
});


/// Instantiate each custom ping once to trigger registration.
#[doc(hidden)]
pub fn register_pings() {
    let _ = &*daemonsession;
    let _ = &*main;
    let _ = &*vpnsession;
}

pub(crate) fn submit_ping_by_id(id: u32, reason: Option<&str>) {
    match id {
        1 => daemonsession.submit(reason),
        2 => main.submit(reason),
        3 => vpnsession.submit(reason),
        _ => {
            // TODO: instrument this error.
            log::error!("Cannot submit unknown ping {} by id.", id);
        }
    }
}
