// -*- mode: Rust -*-

// AUTOGENERATED BY glean_parser.  DO NOT EDIT.

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

#[allow(dead_code)]
use std::collections::HashMap;

use glean::traits::EventRecordingError;
use glean::RecordedEvent;
use once_cell::sync::Lazy;

pub mod performance {
    use glean::private::*;
    #[allow(unused_imports)]
    use glean::{CommonMetricData, Lifetime, TimeUnit};
    #[allow(unused_imports)] // ExtraKeys might be unusued, let's avoid warnings
    use glean::traits::{ExtraKeys, NoExtraKeys};
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from performance.time_to_main_screen
    ///
    /// The time the app took between starting and rendering the main screen.
    pub static time_to_main_screen: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(CommonMetricData {
            name: "time_to_main_screen".into(),
            category: "performance".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

}
pub mod sample {
    use glean::private::*;
    #[allow(unused_imports)]
    use glean::{CommonMetricData, Lifetime, TimeUnit};
    #[allow(unused_imports)] // ExtraKeys might be unusued, let's avoid warnings
    use glean::traits::{ExtraKeys, NoExtraKeys};
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AddonCtaClickedExtra {
        pub r#addon_id: Option<String>,
    }

    impl ExtraKeys for AddonCtaClickedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.addon_cta_clicked
    ///
    /// User clicked primary CTA in an addon
    pub static addon_cta_clicked: Lazy<EventMetric<AddonCtaClickedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "addon_cta_clicked".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AddonMessageStateChangedExtra {
        pub r#message_id: Option<String>,
        pub r#message_state: Option<String>,
    }

    impl ExtraKeys for AddonMessageStateChangedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["message_id", "message_state"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#message_id.and_then(|val| map.insert("message_id".into(), val.to_string()));
          self.r#message_state.and_then(|val| map.insert("message_state".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.addon_message_state_changed
    ///
    /// The addon message' state changed
    pub static addon_message_state_changed: Lazy<EventMetric<AddonMessageStateChangedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "addon_message_state_changed".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AddonStateChangedExtra {
        pub r#addon_id: Option<String>,
        pub r#state: Option<String>,
    }

    impl ExtraKeys for AddonStateChangedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "state"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#state.and_then(|val| map.insert("state".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.addon_state_changed
    ///
    /// An addon's state changed
    pub static addon_state_changed: Lazy<EventMetric<AddonStateChangedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "addon_state_changed".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AndroidDaemonStatusExtra {
        pub r#connection_health_state: Option<String>,
    }

    impl ExtraKeys for AndroidDaemonStatusExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["connection_health_state"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#connection_health_state.and_then(|val| map.insert("connection_health_state".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.android_daemon_status
    ///
    /// A status report of the Android Daemon. Contains information
    /// if the daemon' connection health component.
    /// This will help us understand if that component did activate,
    /// and if so if it did help fix the connection.
    pub static android_daemon_status: Lazy<EventMetric<AndroidDaemonStatusExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "android_daemon_status".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: true,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.app_permissions_view_opened
    ///
    /// The user has opened the app permissions view
    pub static app_permissions_view_opened: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "app_permissions_view_opened".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AppStepExtra {
        pub r#state: Option<String>,
    }

    impl ExtraKeys for AppStepExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["state"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#state.and_then(|val| map.insert("state".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.app_step
    ///
    /// The application state flow (authenticating, subscribing, main, etc).
    pub static app_step: Lazy<EventMetric<AppStepExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "app_step".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.authentication_aborted
    ///
    /// The user has aborted the authentication flow.
    pub static authentication_aborted: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "authentication_aborted".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AuthenticationAcntDelStepExtra {
        pub r#state: Option<String>,
    }

    impl ExtraKeys for AuthenticationAcntDelStepExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["state"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#state.and_then(|val| map.insert("state".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.authentication_acnt_del_step
    ///
    /// The user has advanced in the authentication flow for the account deletion.
    pub static authentication_acnt_del_step: Lazy<EventMetric<AuthenticationAcntDelStepExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "authentication_acnt_del_step".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.authentication_completed
    ///
    /// The user has completed the authentication flow.
    pub static authentication_completed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "authentication_completed".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AuthenticationErrorExtra {
        pub r#reason: Option<String>,
    }

    impl ExtraKeys for AuthenticationErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.authentication_error
    ///
    /// The user is shown an error while authenticating in the app.
    pub static authentication_error: Lazy<EventMetric<AuthenticationErrorExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "authentication_error".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.authentication_failure
    ///
    /// The authentication flow has terminated with an error
    pub static authentication_failure: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "authentication_failure".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.authentication_failure_by_geo
    ///
    /// The authentication flow has terminated with a geo-restriction error
    pub static authentication_failure_by_geo: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "authentication_failure_by_geo".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AuthenticationInappErrorExtra {
        pub r#errno: Option<String>,
        pub r#error: Option<String>,
        pub r#message: Option<String>,
        pub r#validation: Option<String>,
        pub r#verificationmethod: Option<String>,
    }

    impl ExtraKeys for AuthenticationInappErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["errno", "error", "message", "validation", "verificationmethod"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#errno.and_then(|val| map.insert("errno".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#message.and_then(|val| map.insert("message".into(), val.to_string()));
          self.r#validation.and_then(|val| map.insert("validation".into(), val.to_string()));
          self.r#verificationmethod.and_then(|val| map.insert("verificationmethod".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.authentication_inapp_error
    ///
    /// The authentication in app has failed for a non-handled FxA error.
    pub static authentication_inapp_error: Lazy<EventMetric<AuthenticationInappErrorExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "authentication_inapp_error".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AuthenticationInappStepExtra {
        pub r#state: Option<String>,
    }

    impl ExtraKeys for AuthenticationInappStepExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["state"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#state.and_then(|val| map.insert("state".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.authentication_inapp_step
    ///
    /// The user has advanced in the authentication flow.
    pub static authentication_inapp_step: Lazy<EventMetric<AuthenticationInappStepExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "authentication_inapp_step".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.authentication_started
    ///
    /// The user has started the authentication flow.
    pub static authentication_started: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "authentication_started".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AuthenticationSubManageStepExtra {
        pub r#state: Option<String>,
    }

    impl ExtraKeys for AuthenticationSubManageStepExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["state"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#state.and_then(|val| map.insert("state".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.authentication_sub_manage_step
    ///
    /// The user has advanced in the authentication flow for the
    /// subscription management.
    pub static authentication_sub_manage_step: Lazy<EventMetric<AuthenticationSubManageStepExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "authentication_sub_manage_step".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.backend_failure_viewed
    ///
    /// The user has been shown the "Something went wrong…" error view.
    pub static backend_failure_viewed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "backend_failure_viewed".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.billing_not_available_viewed
    ///
    /// The user has viewed an error message after attempting to subscribe
    /// through Google Play store, but the billing service is not availble.
    pub static billing_not_available_viewed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "billing_not_available_viewed".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct BottomNavigationBarClickExtra {
        pub r#bar_button: Option<String>,
    }

    impl ExtraKeys for BottomNavigationBarClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["bar_button"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#bar_button.and_then(|val| map.insert("bar_button".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.bottom_navigation_bar_click
    ///
    /// The user has tapped a bottom navigation bar button.
    pub static bottom_navigation_bar_click: Lazy<EventMetric<BottomNavigationBarClickExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "bottom_navigation_bar_click".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.connection_health_no_signal
    ///
    /// The connection has no signal.
    /// 
    /// This event is recorded in both main application and daemon.
    /// The logic and cadence of health checks for each of these
    /// is not the same. On the daemon this checks are only
    /// done on the Android daemon and not on the iOS network extension.
    /// 
    /// A no signal event event happens when the connection is showing issues,
    /// and a silent switch will not address the issue. On when the connection
    /// is showing issues and there have been previous silent switches which
    /// did not address the issue.
    pub static connection_health_no_signal: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "connection_health_no_signal".into(),
            category: "sample".into(),
            send_in_pings: vec!["daemonsession".into(), "main".into(), "vpnsession".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.connection_health_unstable
    ///
    /// The connection is unstable.
    /// 
    /// This event is recorded in both main application and daemon.
    /// The logic and cadence of health checks for each of these
    /// is not the same. On the daemon this checks are only
    /// done on the Android daemon and not on the iOS network extension.
    /// 
    /// An unstable event happens when the connection is showing issues,
    /// but a silent switch may still address the issue and no previous
    /// silent switches have happened yet.
    pub static connection_health_unstable: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "connection_health_unstable".into(),
            category: "sample".into(),
            send_in_pings: vec!["daemonsession".into(), "main".into(), "vpnsession".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ConnectivityHandshakeTimeoutExtra {
        pub r#server: Option<String>,
        pub r#transport: Option<String>,
    }

    impl ExtraKeys for ConnectivityHandshakeTimeoutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["server", "transport"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#server.and_then(|val| map.insert("server".into(), val.to_string()));
          self.r#transport.and_then(|val| map.insert("transport".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.connectivity_handshake_timeout
    ///
    /// The connection handshake with the VPN server is taking too long, and has
    /// timed out.
    pub static connectivity_handshake_timeout: Lazy<EventMetric<ConnectivityHandshakeTimeoutExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "connectivity_handshake_timeout".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ConnectivityStableExtra {
        pub r#latency: Option<String>,
        pub r#loss: Option<String>,
        pub r#server: Option<String>,
        pub r#stddev: Option<String>,
        pub r#transport: Option<String>,
    }

    impl ExtraKeys for ConnectivityStableExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["latency", "loss", "server", "stddev", "transport"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#latency.and_then(|val| map.insert("latency".into(), val.to_string()));
          self.r#loss.and_then(|val| map.insert("loss".into(), val.to_string()));
          self.r#server.and_then(|val| map.insert("server".into(), val.to_string()));
          self.r#stddev.and_then(|val| map.insert("stddev".into(), val.to_string()));
          self.r#transport.and_then(|val| map.insert("transport".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.connectivity_stable
    ///
    /// The connection has been stable for more than 10 seconds after the
    /// activation
    pub static connectivity_stable: Lazy<EventMetric<ConnectivityStableExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "connectivity_stable".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.controller_state_off
    ///
    /// Controller state is off. It is important to note that mobile reports of
    /// this event are likely to be unreliable because they come from an
    /// non-active background process which is not guaranteed to be alive.
    pub static controller_state_off: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "controller_state_off".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.controller_state_on
    ///
    /// Controller state is on.
    pub static controller_state_on: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "controller_state_on".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ControllerStepExtra {
        pub r#state: Option<String>,
    }

    impl ExtraKeys for ControllerStepExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["state"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#state.and_then(|val| map.insert("state".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.controller_step
    ///
    /// The controller state flow (off, connecting, switching, etc).
    pub static controller_step: Lazy<EventMetric<ControllerStepExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "controller_step".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into(), "vpnsession".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.delete_account_clicked
    ///
    /// The user has clicked the “delete account” button from the
    /// account deletion view.
    pub static delete_account_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "delete_account_clicked".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.delete_account_requested
    ///
    /// The user has clicked the “delete account” button from the profile view.
    pub static delete_account_requested: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "delete_account_requested".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.dns_settings_view_opened
    ///
    /// The user has viewed the advanced DNS Settings
    pub static dns_settings_view_opened: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "dns_settings_view_opened".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ErrorAlertShownExtra {
        pub r#filename: Option<String>,
        pub r#linenumber: Option<u32>,
        pub r#task: Option<String>,
    }

    impl ExtraKeys for ErrorAlertShownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["filename", "linenumber", "task"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#filename.and_then(|val| map.insert("filename".into(), val.to_string()));
          self.r#linenumber.and_then(|val| map.insert("linenumber".into(), val.to_string()));
          self.r#task.and_then(|val| map.insert("task".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.error_alert_shown
    ///
    /// A generic error alet is shown.
    pub static error_alert_shown: Lazy<EventMetric<ErrorAlertShownExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "error_alert_shown".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.get_help_clicked_initialize
    ///
    /// The user has clicked "Get help" from the initial view.
    pub static get_help_clicked_initialize: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "get_help_clicked_initialize".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct GuideClosedExtra {
        pub r#duration_ms: Option<u32>,
        pub r#id: Option<String>,
    }

    impl ExtraKeys for GuideClosedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["duration_ms", "id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#duration_ms.and_then(|val| map.insert("duration_ms".into(), val.to_string()));
          self.r#id.and_then(|val| map.insert("id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.guide_closed
    ///
    /// The user has closed a guide from the tips and tricks page
    pub static guide_closed: Lazy<EventMetric<GuideClosedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "guide_closed".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct GuideOpenedExtra {
        pub r#id: Option<String>,
    }

    impl ExtraKeys for GuideOpenedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#id.and_then(|val| map.insert("id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.guide_opened
    ///
    /// The user has opened a guide from the tips and tricks page
    pub static guide_opened: Lazy<EventMetric<GuideOpenedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "guide_opened".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.help_contact_support_opened
    ///
    /// The user selected the contact support option within the help menu
    pub static help_contact_support_opened: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "help_contact_support_opened".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.help_menu_help_center_opened
    ///
    /// The user selected the help center option within the help menu
    pub static help_menu_help_center_opened: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "help_menu_help_center_opened".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.help_menu_view_logs_opened
    ///
    /// The user selected the view logs option within the help menu
    pub static help_menu_view_logs_opened: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "help_menu_view_logs_opened".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.iap_g_billing_not_available
    ///
    /// The Billing Client was not able to setup itself
    pub static iap_g_billing_not_available: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "iap_g_billing_not_available".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.iap_g_launchbillingflow_failed
    ///
    /// The billing client failed to launch the billing Flow
    pub static iap_g_launchbillingflow_failed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "iap_g_launchbillingflow_failed".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.iap_g_no_sku_details
    ///
    /// There was an attempt to initiate a purchase without an SKU
    pub static iap_g_no_sku_details: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "iap_g_no_sku_details".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.iap_g_purchase_ack_failed
    ///
    /// The billing client failed to acknowledge the purchase
    pub static iap_g_purchase_ack_failed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "iap_g_purchase_ack_failed".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.iap_g_purchases_update_is_null
    ///
    /// Got a "null" response while fetching purchase updates
    pub static iap_g_purchases_update_is_null: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "iap_g_purchases_update_is_null".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct IapGPurchasesUpdatedFailedExtra {
        pub r#reason: Option<String>,
    }

    impl ExtraKeys for IapGPurchasesUpdatedFailedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.iap_g_purchases_updated_failed
    ///
    /// Encountered an error while processing incoming purchase updates
    pub static iap_g_purchases_updated_failed: Lazy<EventMetric<IapGPurchasesUpdatedFailedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "iap_g_purchases_updated_failed".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.iap_g_query_purchases_failed
    ///
    /// The billing client failed to fetch purchases
    pub static iap_g_query_purchases_failed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "iap_g_query_purchases_failed".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.iap_g_query_sku_details_failed
    ///
    /// The billing client failed to fetch the SkuDetails
    pub static iap_g_query_sku_details_failed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "iap_g_query_sku_details_failed".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.iap_g_sku_without_month
    ///
    /// Google play did not send a monthCount for a sku
    pub static iap_g_sku_without_month: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "iap_g_sku_without_month".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.iap_g_unexpected_purchasestate
    ///
    /// The client encountered an unexpected non-purchased product
    pub static iap_g_unexpected_purchasestate: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "iap_g_unexpected_purchasestate".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.iap_restore_sub_started
    ///
    /// The user has started the subscription flow in app
    pub static iap_restore_sub_started: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "iap_restore_sub_started".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct IapSubscriptionCompletedExtra {
        pub r#sku: Option<String>,
    }

    impl ExtraKeys for IapSubscriptionCompletedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["sku"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#sku.and_then(|val| map.insert("sku".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.iap_subscription_completed
    ///
    /// The user has completed the subscription flow in app
    pub static iap_subscription_completed: Lazy<EventMetric<IapSubscriptionCompletedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "iap_subscription_completed".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct IapSubscriptionFailedExtra {
        pub r#error: Option<String>,
        pub r#sku: Option<String>,
    }

    impl ExtraKeys for IapSubscriptionFailedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["error", "sku"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#sku.and_then(|val| map.insert("sku".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.iap_subscription_failed
    ///
    /// The user has completed the subscription flow in app
    pub static iap_subscription_failed: Lazy<EventMetric<IapSubscriptionFailedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "iap_subscription_failed".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct IapSubscriptionStartedExtra {
        pub r#sku: Option<String>,
    }

    impl ExtraKeys for IapSubscriptionStartedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["sku"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#sku.and_then(|val| map.insert("sku".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.iap_subscription_started
    ///
    /// The user has started the subscription flow in app
    pub static iap_subscription_started: Lazy<EventMetric<IapSubscriptionStartedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "iap_subscription_started".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.manage_account_clicked
    ///
    /// The user has clicked the `manage account` button
    pub static manage_account_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "manage_account_clicked".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.max_device_reached
    ///
    /// Device limit reached
    pub static max_device_reached: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "max_device_reached".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct NonDefaultLanguageUsedExtra {
        pub r#language_code: Option<String>,
    }

    impl ExtraKeys for NonDefaultLanguageUsedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["language_code"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#language_code.and_then(|val| map.insert("language_code".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.non_default_language_used
    ///
    /// The user has chosen a default language.
    pub static non_default_language_used: Lazy<EventMetric<NonDefaultLanguageUsedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "non_default_language_used".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.notifications_view_opened
    ///
    /// The user has opened the notifications view
    pub static notifications_view_opened: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "notifications_view_opened".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct OnboardingCtaClickExtra {
        pub r#panel_cta: Option<String>,
        pub r#panel_id: Option<String>,
        pub r#panel_idx: Option<String>,
    }

    impl ExtraKeys for OnboardingCtaClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["panel_cta", "panel_id", "panel_idx"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#panel_cta.and_then(|val| map.insert("panel_cta".into(), val.to_string()));
          self.r#panel_id.and_then(|val| map.insert("panel_id".into(), val.to_string()));
          self.r#panel_idx.and_then(|val| map.insert("panel_idx".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.onboarding_cta_click
    ///
    /// User initiates authentication process from mobile onboarding
    pub static onboarding_cta_click: Lazy<EventMetric<OnboardingCtaClickExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "onboarding_cta_click".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ProfileFlowStateChangedExtra {
        pub r#state: Option<String>,
    }

    impl ExtraKeys for ProfileFlowStateChangedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["state"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#state.and_then(|val| map.insert("state".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.profile_flow_state_changed
    ///
    /// The profile flow state changed.
    pub static profile_flow_state_changed: Lazy<EventMetric<ProfileFlowStateChangedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "profile_flow_state_changed".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct PushMessageReceivedExtra {
        pub r#type: Option<String>,
    }

    impl ExtraKeys for PushMessageReceivedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#type.and_then(|val| map.insert("type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.push_message_received
    ///
    /// A device has been removed from the user's account.
    pub static push_message_received: Lazy<EventMetric<PushMessageReceivedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "push_message_received".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: true,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.server_unavailable_error
    ///
    /// A "Server unavailable" error has occured.
    pub static server_unavailable_error: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "server_unavailable_error".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.settings_view_opened
    ///
    /// The user has opened the settings
    pub static settings_view_opened: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "settings_view_opened".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.sub_not_validated_viewed
    ///
    /// The user has viewed an error message after attempting to subscribe
    /// through Google Play store, but the validation could not be completed.
    pub static sub_not_validated_viewed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "sub_not_validated_viewed".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.subscription_blocked_viewed
    ///
    /// The user has viewed an error message after attempting to subscribe
    /// with an Apple / Google Play ID that already has a subscription.
    pub static subscription_blocked_viewed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "subscription_blocked_viewed".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.support_case_submitted
    ///
    /// The user submitted a support case
    pub static support_case_submitted: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "support_case_submitted".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct TipsAndTricksModalClosedExtra {
        pub r#action: Option<String>,
    }

    impl ExtraKeys for TipsAndTricksModalClosedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.tips_and_tricks_modal_closed
    ///
    /// The user has dismissed the tips and tricks introduction modal
    pub static tips_and_tricks_modal_closed: Lazy<EventMetric<TipsAndTricksModalClosedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "tips_and_tricks_modal_closed".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.tips_and_tricks_modal_shown
    ///
    /// The user has been shown the tips and tricks introduction modal
    pub static tips_and_tricks_modal_shown: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "tips_and_tricks_modal_shown".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from sample.tips_and_tricks_view_opened
    ///
    /// The user has opened the tips and tricks page
    pub static tips_and_tricks_view_opened: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "tips_and_tricks_view_opened".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct UnhandledSubPlanIntervalExtra {
        pub r#interval: Option<String>,
        pub r#interval_count: Option<u32>,
    }

    impl ExtraKeys for UnhandledSubPlanIntervalExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["interval", "interval_count"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#interval.and_then(|val| map.insert("interval".into(), val.to_string()));
          self.r#interval_count.and_then(|val| map.insert("interval_count".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.unhandled_sub_plan_interval
    ///
    /// Unhandled subscription plan interval from the
    /// subscription management view.
    pub static unhandled_sub_plan_interval: Lazy<EventMetric<UnhandledSubPlanIntervalExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "unhandled_sub_plan_interval".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct UpdateStepExtra {
        pub r#state: Option<String>,
    }

    impl ExtraKeys for UpdateStepExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["state"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#state.and_then(|val| map.insert("state".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.update_step
    ///
    /// The update flow (update required available, installer started, etc)
    pub static update_step: Lazy<EventMetric<UpdateStepExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "update_step".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct UserChangedEndpointGeoExtra {
        pub r#server: Option<String>,
    }

    impl ExtraKeys for UserChangedEndpointGeoExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["server"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#server.and_then(|val| map.insert("server".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sample.user_changed_endpoint_geo
    ///
    /// User changed the geography (city, or cities if multihop) of the endpoint
    pub static user_changed_endpoint_geo: Lazy<EventMetric<UserChangedEndpointGeoExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "user_changed_endpoint_geo".into(),
            category: "sample".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod session {
    use glean::private::*;
    #[allow(unused_imports)]
    use glean::{CommonMetricData, Lifetime, TimeUnit};
    #[allow(unused_imports)] // ExtraKeys might be unusued, let's avoid warnings
    use glean::traits::{ExtraKeys, NoExtraKeys};
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from session.apps_excluded
    ///
    /// The number of apps the user is excluding from the VPN tunnel
    pub static apps_excluded: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(CommonMetricData {
            name: "apps_excluded".into(),
            category: "session".into(),
            send_in_pings: vec!["vpnsession".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from session.connection_health_stable_count
    ///
    /// Count of times that the connection health check succeeds.
    /// Collected only on mobile apps.
    pub static connection_health_stable_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(CommonMetricData {
            name: "connection_health_stable_count".into(),
            category: "session".into(),
            send_in_pings: vec!["daemonsession".into(), "vpnsession".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from session.daemon_session_end
    ///
    /// (Mobile-only) The time the user ends a VPN session from the daemon or network
    /// extension
    pub static daemon_session_end: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(CommonMetricData {
            name: "daemon_session_end".into(),
            category: "session".into(),
            send_in_pings: vec!["daemonsession".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from session.daemon_session_id
    ///
    /// (Mobile-only) A unique identifier for each session. This is used to connect
    /// unique VPN sessions across pings, and as a safety check on edge cases of VPN
    /// activation/deactivation, such as a session being started/ended from mobile
    /// system settings.
    pub static daemon_session_id: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(CommonMetricData {
            name: "daemon_session_id".into(),
            category: "session".into(),
            send_in_pings: vec!["daemonsession".into()],
            lifetime: Lifetime::User,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from session.daemon_session_source
    ///
    /// (Mobile-only) Where the VPN session started from, to determine how many
    /// sessions
    /// start outside the app. Values should be "app" or "system". "system" covers
    /// cases like system settings, autostart on boot, tile, etc.
    pub static daemon_session_source: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(CommonMetricData {
            name: "daemon_session_source".into(),
            category: "session".into(),
            send_in_pings: vec!["daemonsession".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from session.daemon_session_start
    ///
    /// (Mobile-only) The time the user starts a VPN session from the daemon or network
    /// extension
    pub static daemon_session_start: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(CommonMetricData {
            name: "daemon_session_start".into(),
            category: "session".into(),
            send_in_pings: vec!["daemonsession".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from session.dns_type
    ///
    /// The type of DNS a user has active:
    /// - NoCustomDNSAvailable: Custom DNS app feature isn't available
    /// - Default: App's default DNS server
    /// - Custom: User has provided a custom valid IP address for their DNS
    /// - BlockAds: One of app's privacy DNS options
    /// - BlockTrackers: One of app's privacy DNS options
    /// - BlockAdsAndTrackers: One of app's privacy DNS options
    /// - BlockMalware: One of app's privacy DNS options
    /// - BlockMalwareAndAds: One of app's privacy DNS options
    /// - BlockMalwareAndTrackers: One of app's privacy DNS options
    /// - BlockMalwareAndAdsAndTrackers: One of app's privacy DNS options
    pub static dns_type: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(CommonMetricData {
            name: "dns_type".into(),
            category: "session".into(),
            send_in_pings: vec!["vpnsession".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from session.installation_id
    ///
    /// A unique identifier to connect the app and daemon Glean instances.
    pub static installation_id: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(CommonMetricData {
            name: "installation_id".into(),
            category: "session".into(),
            send_in_pings: vec!["daemonsession".into(), "vpnsession".into()],
            lifetime: Lifetime::User,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from session.session_end
    ///
    /// The time the user ends a VPN session from the app
    pub static session_end: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(CommonMetricData {
            name: "session_end".into(),
            category: "session".into(),
            send_in_pings: vec!["vpnsession".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from session.session_id
    ///
    /// A unique identifier for each session. This is used to connect unique VPN
    /// sessions across pings, and as a safety check on edge cases of VPN
    /// activation/deactivation, such as a session being started/ended from mobile
    /// system settings.
    pub static session_id: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(CommonMetricData {
            name: "session_id".into(),
            category: "session".into(),
            send_in_pings: vec!["vpnsession".into()],
            lifetime: Lifetime::User,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from session.session_start
    ///
    /// The time the user starts a VPN session from the app
    pub static session_start: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(CommonMetricData {
            name: "session_start".into(),
            category: "session".into(),
            send_in_pings: vec!["vpnsession".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod settings {
    use glean::private::*;
    #[allow(unused_imports)]
    use glean::{CommonMetricData, Lifetime, TimeUnit};
    #[allow(unused_imports)] // ExtraKeys might be unusued, let's avoid warnings
    use glean::traits::{ExtraKeys, NoExtraKeys};
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from settings.connect_on_startup_active
    ///
    /// The status of whether the VPN is activated on device start
    pub static connect_on_startup_active: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(CommonMetricData {
            name: "connect_on_startup_active".into(),
            category: "settings".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from settings.using_system_language
    ///
    /// Status of whether app is being used in language of the operating system
    pub static using_system_language: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(CommonMetricData {
            name: "using_system_language".into(),
            category: "settings".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod interaction {
    use glean::private::*;
    #[allow(unused_imports)]
    use glean::{CommonMetricData, Lifetime, TimeUnit};
    #[allow(unused_imports)] // ExtraKeys might be unusued, let's avoid warnings
    use glean::traits::{ExtraKeys, NoExtraKeys};
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AboutUsSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for AboutUsSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.about_us_selected
    ///
    /// The About us button in the Settings screen was selected
    pub static about_us_selected: Lazy<EventMetric<AboutUsSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "about_us_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AccountSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for AccountSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.account_selected
    ///
    /// User has clicked on their Account in the Settings screen
    pub static account_selected: Lazy<EventMetric<AccountSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "account_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AddApplicationSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for AddApplicationSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.add_application_selected
    ///
    /// The user has clicked on Add application in App Exclusions
    pub static add_application_selected: Lazy<EventMetric<AddApplicationSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "add_application_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AddDevicesSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for AddDevicesSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.add_devices_selected
    ///
    /// The user has clicked the devices step progress bar button in onboarding
    pub static add_devices_selected: Lazy<EventMetric<AddDevicesSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "add_devices_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AlreadyASubscriberSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for AlreadyASubscriberSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.already_a_subscriber_selected
    ///
    /// The "Already a subscriber" button was clicked.
    pub static already_a_subscriber_selected: Lazy<EventMetric<AlreadyASubscriberSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "already_a_subscriber_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AppExclusionsSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for AppExclusionsSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.app_exclusions_selected
    ///
    /// The user has clicked the button that opens
    /// the app exclusions modal
    pub static app_exclusions_selected: Lazy<EventMetric<AppExclusionsSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "app_exclusions_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AppPreferencesSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for AppPreferencesSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.app_preferences_selected
    ///
    /// The App preferences button in the Settings screen was selected
    pub static app_preferences_selected: Lazy<EventMetric<AppPreferencesSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "app_preferences_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ApproveMozillaVpnSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for ApproveMozillaVpnSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.approve_mozilla_vpn_selected
    ///
    /// The user has clicked approve mozilla vpn in onboarding
    pub static approve_mozilla_vpn_selected: Lazy<EventMetric<ApproveMozillaVpnSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "approve_mozilla_vpn_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct BackSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for BackSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.back_selected
    ///
    /// The back arrow button was clicked.
    pub static back_selected: Lazy<EventMetric<BackSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "back_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct BlockAdsDisabledExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for BlockAdsDisabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.block_ads_disabled
    ///
    /// The user has unchecked the block ads checkbox
    pub static block_ads_disabled: Lazy<EventMetric<BlockAdsDisabledExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "block_ads_disabled".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct BlockAdsEnabledExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for BlockAdsEnabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.block_ads_enabled
    ///
    /// The user has checked the block ads checkbox
    pub static block_ads_enabled: Lazy<EventMetric<BlockAdsEnabledExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "block_ads_enabled".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct BlockMalwareDisabledExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for BlockMalwareDisabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.block_malware_disabled
    ///
    /// The user has unchecked the block malware checkbox
    pub static block_malware_disabled: Lazy<EventMetric<BlockMalwareDisabledExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "block_malware_disabled".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct BlockMalwareEnabledExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for BlockMalwareEnabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.block_malware_enabled
    ///
    /// The user has checked the block malware checkbox
    pub static block_malware_enabled: Lazy<EventMetric<BlockMalwareEnabledExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "block_malware_enabled".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct BlockTrackersDisabledExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for BlockTrackersDisabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.block_trackers_disabled
    ///
    /// The user has unchecked the block trackers checkbox
    pub static block_trackers_disabled: Lazy<EventMetric<BlockTrackersDisabledExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "block_trackers_disabled".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct BlockTrackersEnabledExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for BlockTrackersEnabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.block_trackers_enabled
    ///
    /// The user has checked the block trackers checkbox
    pub static block_trackers_enabled: Lazy<EventMetric<BlockTrackersEnabledExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "block_trackers_enabled".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct CancelSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for CancelSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.cancel_selected
    ///
    /// A "cancel" button was clicked.
    pub static cancel_selected: Lazy<EventMetric<CancelSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "cancel_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ChangeEmailSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for ChangeEmailSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.change_email_selected
    ///
    /// The "Change email" button was clicked.
    pub static change_email_selected: Lazy<EventMetric<ChangeEmailSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "change_email_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ChangePlanSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for ChangePlanSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.change_plan_selected
    ///
    /// The user has clicked the “change plan” button from the subscription management
    /// view (monthly web plan)
    pub static change_plan_selected: Lazy<EventMetric<ChangePlanSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "change_plan_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ClearAppExclusionsSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for ClearAppExclusionsSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.clear_app_exclusions_selected
    ///
    /// The user has clicked on Clear all to clear all App Exclusions
    pub static clear_app_exclusions_selected: Lazy<EventMetric<ClearAppExclusionsSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "clear_app_exclusions_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct CloseSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for CloseSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.close_selected
    ///
    /// The user has clicked the "X" button that closes modals.
    /// 
    /// Note: When recorded from the speed test screen, the `screen`
    /// extra key may have the value `unexpected`. That value is used
    /// if this event is recorded while the speed test modal is closed.
    /// Although that is theoretically not possible, the code path for
    /// such a situation exists. Large number of this event with this
    /// value for the `screen` extra key would mean a bug in the code.
    pub static close_selected: Lazy<EventMetric<CloseSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "close_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ConnectOnStartupDisabledExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for ConnectOnStartupDisabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.connect_on_startup_disabled
    ///
    /// The user has disabled connect on startup
    pub static connect_on_startup_disabled: Lazy<EventMetric<ConnectOnStartupDisabledExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "connect_on_startup_disabled".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ConnectOnStartupEnabledExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for ConnectOnStartupEnabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.connect_on_startup_enabled
    ///
    /// The user has enabled connect on startup
    pub static connect_on_startup_enabled: Lazy<EventMetric<ConnectOnStartupEnabledExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "connect_on_startup_enabled".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ContinueSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for ContinueSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.continue_selected
    ///
    /// A "Continue" button was clicked
    pub static continue_selected: Lazy<EventMetric<ContinueSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "continue_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct CreateAccountSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for CreateAccountSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.create_account_selected
    ///
    /// The "Create account" button was clicked.
    pub static create_account_selected: Lazy<EventMetric<CreateAccountSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "create_account_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct DataUseSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for DataUseSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.data_use_selected
    ///
    /// The user has clicked the data step progress bar button in onboarding
    pub static data_use_selected: Lazy<EventMetric<DataUseSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "data_use_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct DnsSettingsSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for DnsSettingsSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.dns_settings_selected
    ///
    /// User clicked on DNS settings in App preferences
    pub static dns_settings_selected: Lazy<EventMetric<DnsSettingsSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "dns_settings_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EditSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for EditSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.edit_selected
    ///
    /// The user has clicked the "edit account" button
    pub static edit_selected: Lazy<EventMetric<EditSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "edit_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ForgotYourPasswordSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for ForgotYourPasswordSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.forgot_your_password_selected
    ///
    /// The "Forgot your password?" button was clicked.
    pub static forgot_your_password_selected: Lazy<EventMetric<ForgotYourPasswordSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "forgot_your_password_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct GetHelpSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for GetHelpSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.get_help_selected
    ///
    /// The "Get help" link was clicked.
    pub static get_help_selected: Lazy<EventMetric<GetHelpSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "get_help_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct GetStartedSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for GetStartedSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.get_started_selected
    ///
    /// The user has clicked get started in onboarding
    pub static get_started_selected: Lazy<EventMetric<GetStartedSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "get_started_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct GoBackSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for GoBackSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.go_back_selected
    ///
    /// A "go back" button was clicked
    pub static go_back_selected: Lazy<EventMetric<GoBackSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "go_back_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct HomeSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for HomeSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.home_selected
    ///
    /// User has clicked on the Home button
    pub static home_selected: Lazy<EventMetric<HomeSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "home_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct LanguageSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for LanguageSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.language_selected
    ///
    /// User clicked on Language in App preferences
    pub static language_selected: Lazy<EventMetric<LanguageSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "language_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ManageSubscriptionSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for ManageSubscriptionSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.manage_subscription_selected
    ///
    /// The user has clicked the “manage subscription” button from the subscription
    /// management view
    pub static manage_subscription_selected: Lazy<EventMetric<ManageSubscriptionSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "manage_subscription_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct MessagesSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for MessagesSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.messages_selected
    ///
    /// User has clicked on the Messages button
    pub static messages_selected: Lazy<EventMetric<MessagesSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "messages_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct MorePrivacySelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for MorePrivacySelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.more_privacy_selected
    ///
    /// The user has clicked the privacy step progress bar button in onboarding
    pub static more_privacy_selected: Lazy<EventMetric<MorePrivacySelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "more_privacy_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct MyDevicesSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for MyDevicesSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.my_devices_selected
    ///
    /// The My devices button in the Settings screen was selected
    pub static my_devices_selected: Lazy<EventMetric<MyDevicesSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "my_devices_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct NotificationsSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for NotificationsSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.notifications_selected
    ///
    /// User clicked on Notifications in App preferences
    pub static notifications_selected: Lazy<EventMetric<NotificationsSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "notifications_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct OpenConnectionInfoSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for OpenConnectionInfoSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.open_connection_info_selected
    ///
    /// The user has clicked the button that opens
    /// the connection information modal
    pub static open_connection_info_selected: Lazy<EventMetric<OpenConnectionInfoSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "open_connection_info_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct PastePasswordSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for PastePasswordSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.paste_password_selected
    ///
    /// The "Paste" button was clicked on the password input.
    pub static paste_password_selected: Lazy<EventMetric<PastePasswordSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "paste_password_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct PrivacyFeaturesSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for PrivacyFeaturesSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.privacy_features_selected
    ///
    /// The Privacy features button in the Settings screen was selected
    pub static privacy_features_selected: Lazy<EventMetric<PrivacyFeaturesSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "privacy_features_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct PrivacyNoticeSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for PrivacyNoticeSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.privacy_notice_selected
    ///
    /// The "Privacy notice" button was clicked.
    pub static privacy_notice_selected: Lazy<EventMetric<PrivacyNoticeSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "privacy_notice_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct RefreshSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for RefreshSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.refresh_selected
    ///
    /// The user has clicked on the button to refresh the
    /// speed test results
    pub static refresh_selected: Lazy<EventMetric<RefreshSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "refresh_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ResendCodeSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for ResendCodeSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.resend_code_selected
    ///
    /// The "Resend code" button was clicked in one of the security code verification
    /// screens.
    pub static resend_code_selected: Lazy<EventMetric<ResendCodeSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "resend_code_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SearchSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for SearchSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.search_selected
    ///
    /// The user has clicked on the search field in app exclusions
    pub static search_selected: Lazy<EventMetric<SearchSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "search_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SettingsSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for SettingsSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.settings_selected
    ///
    /// User has clicked on the Settings button
    pub static settings_selected: Lazy<EventMetric<SettingsSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "settings_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ShowAndroidQrSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for ShowAndroidQrSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.show_android_qr_selected
    ///
    /// The user has selected the android segment of the devices toggle in onboarding
    pub static show_android_qr_selected: Lazy<EventMetric<ShowAndroidQrSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "show_android_qr_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ShowIosQrSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for ShowIosQrSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.show_ios_qr_selected
    ///
    /// The user has selected the android segment of the devices toggle in onboarding
    pub static show_ios_qr_selected: Lazy<EventMetric<ShowIosQrSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "show_ios_qr_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SignInSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for SignInSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.sign_in_selected
    ///
    /// A "Sign in" button was clicked.
    pub static sign_in_selected: Lazy<EventMetric<SignInSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "sign_in_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SignOutSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for SignOutSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.sign_out_selected
    ///
    /// The "Sign out" button was clicked.
    pub static sign_out_selected: Lazy<EventMetric<SignOutSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "sign_out_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SignupSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for SignupSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.signup_selected
    ///
    /// The "Sign up" button was clicked.
    pub static signup_selected: Lazy<EventMetric<SignupSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "signup_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct StartSpeedTestSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for StartSpeedTestSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.start_speed_test_selected
    ///
    /// The user has clicked on the button that triggers the speed test
    pub static start_speed_test_selected: Lazy<EventMetric<StartSpeedTestSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "start_speed_test_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SubscribeNowSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for SubscribeNowSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.subscribe_now_selected
    ///
    /// The "Subscribe now" button was clicked.
    pub static subscribe_now_selected: Lazy<EventMetric<SubscribeNowSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "subscribe_now_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct TermsOfServiceSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for TermsOfServiceSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.terms_of_service_selected
    ///
    /// The "Terms of Service" button was clicked.
    pub static terms_of_service_selected: Lazy<EventMetric<TermsOfServiceSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "terms_of_service_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct TipsAndTricksSelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for TipsAndTricksSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.tips_and_tricks_selected
    ///
    /// The Tips and tricks button in the Settings screen was selected
    pub static tips_and_tricks_selected: Lazy<EventMetric<TipsAndTricksSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "tips_and_tricks_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct VerifySelectedExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for VerifySelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.verify_selected
    ///
    /// The "Verify" button was clicked in one of the security code verification
    /// screens.
    pub static verify_selected: Lazy<EventMetric<VerifySelectedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "verify_selected".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct VpnOnStartupDisabledExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for VpnOnStartupDisabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.vpn_on_startup_disabled
    ///
    /// Disabled VPN on startup
    pub static vpn_on_startup_disabled: Lazy<EventMetric<VpnOnStartupDisabledExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "vpn_on_startup_disabled".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct VpnOnStartupEnabledExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for VpnOnStartupEnabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from interaction.vpn_on_startup_enabled
    ///
    /// Enabled VPN on startup
    pub static vpn_on_startup_enabled: Lazy<EventMetric<VpnOnStartupEnabledExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "vpn_on_startup_enabled".into(),
            category: "interaction".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod impression {
    use glean::private::*;
    #[allow(unused_imports)]
    use glean::{CommonMetricData, Lifetime, TimeUnit};
    #[allow(unused_imports)] // ExtraKeys might be unusued, let's avoid warnings
    use glean::traits::{ExtraKeys, NoExtraKeys};
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AccountScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for AccountScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.account_screen
    ///
    /// The user has viewed the subscription management screen
    pub static account_screen: Lazy<EventMetric<AccountScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "account_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AppExclusionsScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for AppExclusionsScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.app_exclusions_screen
    ///
    /// The user has just moved on to the app exclusions screen
    pub static app_exclusions_screen: Lazy<EventMetric<AppExclusionsScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "app_exclusions_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AppPreferencesScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for AppPreferencesScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.app_preferences_screen
    ///
    /// User is on the App preferences screen
    pub static app_preferences_screen: Lazy<EventMetric<AppPreferencesScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "app_preferences_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ConfirmingSubscriptionScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for ConfirmingSubscriptionScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.confirming_subscription_screen
    ///
    /// The user has entered the "Confirming subscription" screen.
    pub static confirming_subscription_screen: Lazy<EventMetric<ConfirmingSubscriptionScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "confirming_subscription_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ConnectOnStartupScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for ConnectOnStartupScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.connect_on_startup_screen
    ///
    /// The user has viewed the connect on startup onboarding slide.
    pub static connect_on_startup_screen: Lazy<EventMetric<ConnectOnStartupScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "connect_on_startup_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ConnectionInfoScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for ConnectionInfoScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.connection_info_screen
    ///
    /// The user has just moved on to the screen that shows
    /// the connection information
    pub static connection_info_screen: Lazy<EventMetric<ConnectionInfoScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "connection_info_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ContinueInBrowserScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for ContinueInBrowserScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.continue_in_browser_screen
    ///
    /// The user has entered the "Continue in browser" screen.
    pub static continue_in_browser_screen: Lazy<EventMetric<ContinueInBrowserScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "continue_in_browser_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct CreatePasswordScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for CreatePasswordScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.create_password_screen
    ///
    /// The user has entered the "Create password" screen.
    pub static create_password_screen: Lazy<EventMetric<CreatePasswordScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "create_password_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct DataCollectionScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for DataCollectionScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.data_collection_screen
    ///
    /// The user has viewed the data collection onboarding slide.
    pub static data_collection_screen: Lazy<EventMetric<DataCollectionScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "data_collection_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct DnsSettingsScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for DnsSettingsScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.dns_settings_screen
    ///
    /// User has opened the DNS settings screen
    pub static dns_settings_screen: Lazy<EventMetric<DnsSettingsScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "dns_settings_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EnterEmailScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for EnterEmailScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.enter_email_screen
    ///
    /// The user has entered the "Enter email" screen.
    pub static enter_email_screen: Lazy<EventMetric<EnterEmailScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "enter_email_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EnterPasswordScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for EnterPasswordScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.enter_password_screen
    ///
    /// The user has entered the "Enter password" screen.
    pub static enter_password_screen: Lazy<EventMetric<EnterPasswordScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "enter_password_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EnterSecurityCodeScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for EnterSecurityCodeScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.enter_security_code_screen
    ///
    /// The user has entered the screen to enter a TOTP security code.
    pub static enter_security_code_screen: Lazy<EventMetric<EnterSecurityCodeScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "enter_security_code_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EnterUnblockCodeScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for EnterUnblockCodeScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.enter_unblock_code_screen
    ///
    /// The user has entered the "Enter unblock code" screen.
    pub static enter_unblock_code_screen: Lazy<EventMetric<EnterUnblockCodeScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "enter_unblock_code_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EnterVerificationCodeScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for EnterVerificationCodeScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.enter_verification_code_screen
    ///
    /// The user has entered the screen to enter email verification code.
    pub static enter_verification_code_screen: Lazy<EventMetric<EnterVerificationCodeScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "enter_verification_code_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct GetMorePrivacyScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for GetMorePrivacyScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.get_more_privacy_screen
    ///
    /// The user has viewed the get more privacy onboarding slide.
    pub static get_more_privacy_screen: Lazy<EventMetric<GetMorePrivacyScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "get_more_privacy_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct InstallOn5DevicesScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for InstallOn5DevicesScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.install_on_5_devices_screen
    ///
    /// The user has viewed the install on 5 devices onboarding slide.
    pub static install_on_5_devices_screen: Lazy<EventMetric<InstallOn5DevicesScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "install_on_5_devices_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct LanguageScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for LanguageScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.language_screen
    ///
    /// User has opened the Language screen
    pub static language_screen: Lazy<EventMetric<LanguageScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "language_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct MainScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for MainScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.main_screen
    ///
    /// The user has just moved on to the main screen
    /// i.e. the screen with the VPN toggle button.
    pub static main_screen: Lazy<EventMetric<MainScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "main_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct NetworkPermissionsScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for NetworkPermissionsScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.network_permissions_screen
    ///
    /// The user has viewed the grant network permissions onboarding slide.
    pub static network_permissions_screen: Lazy<EventMetric<NetworkPermissionsScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "network_permissions_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SettingsScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for SettingsScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.settings_screen
    ///
    /// The user has just moved on to the settings screen
    pub static settings_screen: Lazy<EventMetric<SettingsScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "settings_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SignupScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for SignupScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.signup_screen
    ///
    /// The user has entered the "Sign up" screen.
    pub static signup_screen: Lazy<EventMetric<SignupScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "signup_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SpeedTestCompletedScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for SpeedTestCompletedScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.speed_test_completed_screen
    ///
    /// The user has just moved on to the screen that shows
    /// the speed test results
    pub static speed_test_completed_screen: Lazy<EventMetric<SpeedTestCompletedScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "speed_test_completed_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SpeedTestErrorScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for SpeedTestErrorScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.speed_test_error_screen
    ///
    /// The user has just moved on to the screen that shows
    /// the speed test error
    pub static speed_test_error_screen: Lazy<EventMetric<SpeedTestErrorScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "speed_test_error_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SpeedTestLoadingScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for SpeedTestLoadingScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.speed_test_loading_screen
    ///
    /// The user has just moved on to the screen that shows
    /// the loading animation for the speed test results
    pub static speed_test_loading_screen: Lazy<EventMetric<SpeedTestLoadingScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "speed_test_loading_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SubscriptionNeededScreenExtra {
        pub r#screen: Option<String>,
    }

    impl ExtraKeys for SubscriptionNeededScreenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["screen"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#screen.and_then(|val| map.insert("screen".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from impression.subscription_needed_screen
    ///
    /// The user has entered the "Subscription needed" screen.
    pub static subscription_needed_screen: Lazy<EventMetric<SubscriptionNeededScreenExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "subscription_needed_screen".into(),
            category: "impression".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod outcome {
    use glean::private::*;
    #[allow(unused_imports)]
    use glean::{CommonMetricData, Lifetime, TimeUnit};
    #[allow(unused_imports)] // ExtraKeys might be unusued, let's avoid warnings
    use glean::traits::{ExtraKeys, NoExtraKeys};
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from outcome.login_ended
    ///
    /// The user has just completed the login process.
    pub static login_ended: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "login_ended".into(),
            category: "outcome".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from outcome.login_started
    ///
    /// The user has started the login process.
    pub static login_started: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "login_started".into(),
            category: "outcome".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from outcome.onboarding_completed
    ///
    /// The user has just completed the onboarding experience
    pub static onboarding_completed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "onboarding_completed".into(),
            category: "outcome".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from outcome.onboarding_ntwrk_perm_denied
    ///
    /// The user has denied the VPN configuration to be created on the system
    pub static onboarding_ntwrk_perm_denied: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "onboarding_ntwrk_perm_denied".into(),
            category: "outcome".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from outcome.onboarding_ntwrk_perm_granted
    ///
    /// The user has allowed the VPN configuration to be created on the system
    pub static onboarding_ntwrk_perm_granted: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "onboarding_ntwrk_perm_granted".into(),
            category: "outcome".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from outcome.onboarding_started
    ///
    /// The user has just started the onboarding experience for the first time
    pub static onboarding_started: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "onboarding_started".into(),
            category: "outcome".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from outcome.registration_completed
    ///
    /// The user has just completed the registration process.
    pub static registration_completed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "registration_completed".into(),
            category: "outcome".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from outcome.registration_started
    ///
    /// The user has started the registration process.
    pub static registration_started: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "registration_started".into(),
            category: "outcome".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SpeedTestCompletedExtra {
        pub r#outcome: Option<String>,
        pub r#speed: Option<String>,
    }

    impl ExtraKeys for SpeedTestCompletedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["outcome", "speed"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#outcome.and_then(|val| map.insert("outcome".into(), val.to_string()));
          self.r#speed.and_then(|val| map.insert("speed".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from outcome.speed_test_completed
    ///
    /// A speed test has just been completed,
    /// this is a backend event and does not necessarily
    /// mean the user has seen the speed test completed screen.
    /// For that, there is the impression.speed_test_result_completed event.
    pub static speed_test_completed: Lazy<EventMetric<SpeedTestCompletedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "speed_test_completed".into(),
            category: "outcome".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from outcome.subscription_completed
    ///
    /// The user has just completed the subscription process.
    pub static subscription_completed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "subscription_completed".into(),
            category: "outcome".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from outcome.subscription_started
    ///
    /// The user has just started the subscription process.
    pub static subscription_started: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "subscription_started".into(),
            category: "outcome".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct TwoFaVerificationFailedExtra {
        pub r#type: Option<String>,
    }

    impl ExtraKeys for TwoFaVerificationFailedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#type.and_then(|val| map.insert("type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from outcome.two_fa_verification_failed
    ///
    /// The user has just failed the 2FA process.
    pub static two_fa_verification_failed: Lazy<EventMetric<TwoFaVerificationFailedExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "two_fa_verification_failed".into(),
            category: "outcome".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct TwoFaVerificationSucceededExtra {
        pub r#type: Option<String>,
    }

    impl ExtraKeys for TwoFaVerificationSucceededExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#type.and_then(|val| map.insert("type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from outcome.two_fa_verification_succeeded
    ///
    /// The user has just succeeded in the 2FA process.
    pub static two_fa_verification_succeeded: Lazy<EventMetric<TwoFaVerificationSucceededExtra>> = Lazy::new(|| {
        EventMetric::new(CommonMetricData {
            name: "two_fa_verification_succeeded".into(),
            category: "outcome".into(),
            send_in_pings: vec!["main".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}

pub static TIMING_DISTRIBUTION_MAP: Lazy<HashMap<u32, &Lazy<glean::private::TimingDistributionMetric>>> = Lazy::new(|| {
    let mut map: HashMap<u32, &Lazy<glean::private::TimingDistributionMetric>> = HashMap::with_capacity(1);
    map.insert(1, &performance::time_to_main_screen);
    map
});
pub static COUNTER_MAP: Lazy<HashMap<u32, &Lazy<glean::private::CounterMetric>>> = Lazy::new(|| {
    let mut map: HashMap<u32, &Lazy<glean::private::CounterMetric>> = HashMap::with_capacity(1);
    map.insert(71, &session::connection_health_stable_count);
    map
});
pub static STRING_MAP: Lazy<HashMap<u32, &Lazy<glean::private::StringMetric>>> = Lazy::new(|| {
    let mut map: HashMap<u32, &Lazy<glean::private::StringMetric>> = HashMap::with_capacity(2);
    map.insert(74, &session::daemon_session_source);
    map.insert(76, &session::dns_type);
    map
});
pub static QUANTITY_MAP: Lazy<HashMap<u32, &Lazy<glean::private::QuantityMetric>>> = Lazy::new(|| {
    let mut map: HashMap<u32, &Lazy<glean::private::QuantityMetric>> = HashMap::with_capacity(1);
    map.insert(70, &session::apps_excluded);
    map
});
pub static DATETIME_MAP: Lazy<HashMap<u32, &Lazy<glean::private::DatetimeMetric>>> = Lazy::new(|| {
    let mut map: HashMap<u32, &Lazy<glean::private::DatetimeMetric>> = HashMap::with_capacity(4);
    map.insert(72, &session::daemon_session_end);
    map.insert(75, &session::daemon_session_start);
    map.insert(78, &session::session_end);
    map.insert(80, &session::session_start);
    map
});
pub static BOOLEAN_MAP: Lazy<HashMap<u32, &Lazy<glean::private::BooleanMetric>>> = Lazy::new(|| {
    let mut map: HashMap<u32, &Lazy<glean::private::BooleanMetric>> = HashMap::with_capacity(2);
    map.insert(81, &settings::connect_on_startup_active);
    map.insert(82, &settings::using_system_language);
    map
});
pub static UUID_MAP: Lazy<HashMap<u32, &Lazy<glean::private::UuidMetric>>> = Lazy::new(|| {
    let mut map: HashMap<u32, &Lazy<glean::private::UuidMetric>> = HashMap::with_capacity(3);
    map.insert(73, &session::daemon_session_id);
    map.insert(77, &session::installation_id);
    map.insert(79, &session::session_id);
    map
});

/// Wrapper to record an event based on its metric ID.
///
/// # Arguments
///
/// * `metric_id` - The metric's ID to look up
/// * `extra`     - An map of (extra key id, string) pairs.
///                 The map will be decoded into the appropriate `ExtraKeys` type.
/// # Returns
///
/// Returns `Ok(())` if the event was found and `record` was called with the given `extra`,
/// or an `EventRecordingError::InvalidId` if no event by that ID exists
/// or an `EventRecordingError::InvalidExtraKey` if the `extra` map could not be deserialized.
pub(crate) fn record_event_by_id(metric_id: u32, extra: HashMap<String, String>) -> Result<(), EventRecordingError> {
    match metric_id {
        2 => {
            sample::addon_cta_clicked.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        3 => {
            sample::addon_message_state_changed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        4 => {
            sample::addon_state_changed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        5 => {
            sample::android_daemon_status.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        6 => {
            sample::app_permissions_view_opened.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        7 => {
            sample::app_step.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        8 => {
            sample::authentication_aborted.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        9 => {
            sample::authentication_acnt_del_step.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        10 => {
            sample::authentication_completed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        11 => {
            sample::authentication_error.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        12 => {
            sample::authentication_failure.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        13 => {
            sample::authentication_failure_by_geo.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        14 => {
            sample::authentication_inapp_error.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        15 => {
            sample::authentication_inapp_step.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        16 => {
            sample::authentication_started.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        17 => {
            sample::authentication_sub_manage_step.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        18 => {
            sample::backend_failure_viewed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        19 => {
            sample::billing_not_available_viewed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        20 => {
            sample::bottom_navigation_bar_click.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        21 => {
            sample::connection_health_no_signal.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        22 => {
            sample::connection_health_unstable.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        23 => {
            sample::connectivity_handshake_timeout.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        24 => {
            sample::connectivity_stable.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        25 => {
            sample::controller_state_off.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        26 => {
            sample::controller_state_on.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        27 => {
            sample::controller_step.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        28 => {
            sample::delete_account_clicked.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        29 => {
            sample::delete_account_requested.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        30 => {
            sample::dns_settings_view_opened.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        31 => {
            sample::error_alert_shown.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        32 => {
            sample::get_help_clicked_initialize.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        33 => {
            sample::guide_closed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        34 => {
            sample::guide_opened.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        35 => {
            sample::help_contact_support_opened.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        36 => {
            sample::help_menu_help_center_opened.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        37 => {
            sample::help_menu_view_logs_opened.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        38 => {
            sample::iap_g_billing_not_available.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        39 => {
            sample::iap_g_launchbillingflow_failed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        40 => {
            sample::iap_g_no_sku_details.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        41 => {
            sample::iap_g_purchase_ack_failed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        42 => {
            sample::iap_g_purchases_update_is_null.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        43 => {
            sample::iap_g_purchases_updated_failed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        44 => {
            sample::iap_g_query_purchases_failed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        45 => {
            sample::iap_g_query_sku_details_failed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        46 => {
            sample::iap_g_sku_without_month.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        47 => {
            sample::iap_g_unexpected_purchasestate.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        48 => {
            sample::iap_restore_sub_started.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        49 => {
            sample::iap_subscription_completed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        50 => {
            sample::iap_subscription_failed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        51 => {
            sample::iap_subscription_started.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        52 => {
            sample::manage_account_clicked.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        53 => {
            sample::max_device_reached.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        54 => {
            sample::non_default_language_used.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        55 => {
            sample::notifications_view_opened.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        56 => {
            sample::onboarding_cta_click.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        57 => {
            sample::profile_flow_state_changed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        58 => {
            sample::push_message_received.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        59 => {
            sample::server_unavailable_error.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        60 => {
            sample::settings_view_opened.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        61 => {
            sample::sub_not_validated_viewed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        62 => {
            sample::subscription_blocked_viewed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        63 => {
            sample::support_case_submitted.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        64 => {
            sample::tips_and_tricks_modal_closed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        65 => {
            sample::tips_and_tricks_modal_shown.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        66 => {
            sample::tips_and_tricks_view_opened.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        67 => {
            sample::unhandled_sub_plan_interval.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        68 => {
            sample::update_step.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        69 => {
            sample::user_changed_endpoint_geo.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        83 => {
            interaction::about_us_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        84 => {
            interaction::account_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        85 => {
            interaction::add_application_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        86 => {
            interaction::add_devices_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        87 => {
            interaction::already_a_subscriber_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        88 => {
            interaction::app_exclusions_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        89 => {
            interaction::app_preferences_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        90 => {
            interaction::approve_mozilla_vpn_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        91 => {
            interaction::back_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        92 => {
            interaction::block_ads_disabled.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        93 => {
            interaction::block_ads_enabled.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        94 => {
            interaction::block_malware_disabled.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        95 => {
            interaction::block_malware_enabled.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        96 => {
            interaction::block_trackers_disabled.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        97 => {
            interaction::block_trackers_enabled.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        98 => {
            interaction::cancel_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        99 => {
            interaction::change_email_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        100 => {
            interaction::change_plan_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        101 => {
            interaction::clear_app_exclusions_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        102 => {
            interaction::close_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        103 => {
            interaction::connect_on_startup_disabled.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        104 => {
            interaction::connect_on_startup_enabled.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        105 => {
            interaction::continue_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        106 => {
            interaction::create_account_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        107 => {
            interaction::data_use_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        108 => {
            interaction::dns_settings_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        109 => {
            interaction::edit_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        110 => {
            interaction::forgot_your_password_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        111 => {
            interaction::get_help_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        112 => {
            interaction::get_started_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        113 => {
            interaction::go_back_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        114 => {
            interaction::home_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        115 => {
            interaction::language_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        116 => {
            interaction::manage_subscription_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        117 => {
            interaction::messages_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        118 => {
            interaction::more_privacy_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        119 => {
            interaction::my_devices_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        120 => {
            interaction::notifications_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        121 => {
            interaction::open_connection_info_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        122 => {
            interaction::paste_password_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        123 => {
            interaction::privacy_features_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        124 => {
            interaction::privacy_notice_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        125 => {
            interaction::refresh_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        126 => {
            interaction::resend_code_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        127 => {
            interaction::search_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        128 => {
            interaction::settings_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        129 => {
            interaction::show_android_qr_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        130 => {
            interaction::show_ios_qr_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        131 => {
            interaction::sign_in_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        132 => {
            interaction::sign_out_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        133 => {
            interaction::signup_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        134 => {
            interaction::start_speed_test_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        135 => {
            interaction::subscribe_now_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        136 => {
            interaction::terms_of_service_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        137 => {
            interaction::tips_and_tricks_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        138 => {
            interaction::verify_selected.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        139 => {
            interaction::vpn_on_startup_disabled.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        140 => {
            interaction::vpn_on_startup_enabled.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        141 => {
            impression::account_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        142 => {
            impression::app_exclusions_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        143 => {
            impression::app_preferences_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        144 => {
            impression::confirming_subscription_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        145 => {
            impression::connect_on_startup_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        146 => {
            impression::connection_info_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        147 => {
            impression::continue_in_browser_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        148 => {
            impression::create_password_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        149 => {
            impression::data_collection_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        150 => {
            impression::dns_settings_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        151 => {
            impression::enter_email_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        152 => {
            impression::enter_password_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        153 => {
            impression::enter_security_code_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        154 => {
            impression::enter_unblock_code_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        155 => {
            impression::enter_verification_code_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        156 => {
            impression::get_more_privacy_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        157 => {
            impression::install_on_5_devices_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        158 => {
            impression::language_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        159 => {
            impression::main_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        160 => {
            impression::network_permissions_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        161 => {
            impression::settings_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        162 => {
            impression::signup_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        163 => {
            impression::speed_test_completed_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        164 => {
            impression::speed_test_error_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        165 => {
            impression::speed_test_loading_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        166 => {
            impression::subscription_needed_screen.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        167 => {
            outcome::login_ended.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        168 => {
            outcome::login_started.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        169 => {
            outcome::onboarding_completed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        170 => {
            outcome::onboarding_ntwrk_perm_denied.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        171 => {
            outcome::onboarding_ntwrk_perm_granted.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        172 => {
            outcome::onboarding_started.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        173 => {
            outcome::registration_completed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        174 => {
            outcome::registration_started.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        175 => {
            outcome::speed_test_completed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        176 => {
            outcome::subscription_completed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        177 => {
            outcome::subscription_started.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        178 => {
            outcome::two_fa_verification_failed.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        179 => {
            outcome::two_fa_verification_succeeded.record_with_time(glean::get_timestamp_ms(), extra);
            Ok(())
        }
        _ => Err(EventRecordingError::InvalidId),
    }
}

/// Wrapper to record an event based on its metric ID.
///
/// # Arguments
///
/// * `metric_id` - The metric's ID to look up.
///
/// # Returns
///
/// Returns `Ok(())` if the event was found and `record` was called with the given `extra`,
/// or an `EventRecordingError::InvalidId` if no event by that ID exists
/// or an `EventRecordingError::InvalidExtraKey` if the `extra` map could not be deserialized.
pub(crate) fn record_event_by_id_no_extra(metric_id: u32) -> Result<(), EventRecordingError> {
    match metric_id {
        2 => {
            sample::addon_cta_clicked.record(None);
            Ok(())
        }
        3 => {
            sample::addon_message_state_changed.record(None);
            Ok(())
        }
        4 => {
            sample::addon_state_changed.record(None);
            Ok(())
        }
        5 => {
            sample::android_daemon_status.record(None);
            Ok(())
        }
        6 => {
            sample::app_permissions_view_opened.record(None);
            Ok(())
        }
        7 => {
            sample::app_step.record(None);
            Ok(())
        }
        8 => {
            sample::authentication_aborted.record(None);
            Ok(())
        }
        9 => {
            sample::authentication_acnt_del_step.record(None);
            Ok(())
        }
        10 => {
            sample::authentication_completed.record(None);
            Ok(())
        }
        11 => {
            sample::authentication_error.record(None);
            Ok(())
        }
        12 => {
            sample::authentication_failure.record(None);
            Ok(())
        }
        13 => {
            sample::authentication_failure_by_geo.record(None);
            Ok(())
        }
        14 => {
            sample::authentication_inapp_error.record(None);
            Ok(())
        }
        15 => {
            sample::authentication_inapp_step.record(None);
            Ok(())
        }
        16 => {
            sample::authentication_started.record(None);
            Ok(())
        }
        17 => {
            sample::authentication_sub_manage_step.record(None);
            Ok(())
        }
        18 => {
            sample::backend_failure_viewed.record(None);
            Ok(())
        }
        19 => {
            sample::billing_not_available_viewed.record(None);
            Ok(())
        }
        20 => {
            sample::bottom_navigation_bar_click.record(None);
            Ok(())
        }
        21 => {
            sample::connection_health_no_signal.record(None);
            Ok(())
        }
        22 => {
            sample::connection_health_unstable.record(None);
            Ok(())
        }
        23 => {
            sample::connectivity_handshake_timeout.record(None);
            Ok(())
        }
        24 => {
            sample::connectivity_stable.record(None);
            Ok(())
        }
        25 => {
            sample::controller_state_off.record(None);
            Ok(())
        }
        26 => {
            sample::controller_state_on.record(None);
            Ok(())
        }
        27 => {
            sample::controller_step.record(None);
            Ok(())
        }
        28 => {
            sample::delete_account_clicked.record(None);
            Ok(())
        }
        29 => {
            sample::delete_account_requested.record(None);
            Ok(())
        }
        30 => {
            sample::dns_settings_view_opened.record(None);
            Ok(())
        }
        31 => {
            sample::error_alert_shown.record(None);
            Ok(())
        }
        32 => {
            sample::get_help_clicked_initialize.record(None);
            Ok(())
        }
        33 => {
            sample::guide_closed.record(None);
            Ok(())
        }
        34 => {
            sample::guide_opened.record(None);
            Ok(())
        }
        35 => {
            sample::help_contact_support_opened.record(None);
            Ok(())
        }
        36 => {
            sample::help_menu_help_center_opened.record(None);
            Ok(())
        }
        37 => {
            sample::help_menu_view_logs_opened.record(None);
            Ok(())
        }
        38 => {
            sample::iap_g_billing_not_available.record(None);
            Ok(())
        }
        39 => {
            sample::iap_g_launchbillingflow_failed.record(None);
            Ok(())
        }
        40 => {
            sample::iap_g_no_sku_details.record(None);
            Ok(())
        }
        41 => {
            sample::iap_g_purchase_ack_failed.record(None);
            Ok(())
        }
        42 => {
            sample::iap_g_purchases_update_is_null.record(None);
            Ok(())
        }
        43 => {
            sample::iap_g_purchases_updated_failed.record(None);
            Ok(())
        }
        44 => {
            sample::iap_g_query_purchases_failed.record(None);
            Ok(())
        }
        45 => {
            sample::iap_g_query_sku_details_failed.record(None);
            Ok(())
        }
        46 => {
            sample::iap_g_sku_without_month.record(None);
            Ok(())
        }
        47 => {
            sample::iap_g_unexpected_purchasestate.record(None);
            Ok(())
        }
        48 => {
            sample::iap_restore_sub_started.record(None);
            Ok(())
        }
        49 => {
            sample::iap_subscription_completed.record(None);
            Ok(())
        }
        50 => {
            sample::iap_subscription_failed.record(None);
            Ok(())
        }
        51 => {
            sample::iap_subscription_started.record(None);
            Ok(())
        }
        52 => {
            sample::manage_account_clicked.record(None);
            Ok(())
        }
        53 => {
            sample::max_device_reached.record(None);
            Ok(())
        }
        54 => {
            sample::non_default_language_used.record(None);
            Ok(())
        }
        55 => {
            sample::notifications_view_opened.record(None);
            Ok(())
        }
        56 => {
            sample::onboarding_cta_click.record(None);
            Ok(())
        }
        57 => {
            sample::profile_flow_state_changed.record(None);
            Ok(())
        }
        58 => {
            sample::push_message_received.record(None);
            Ok(())
        }
        59 => {
            sample::server_unavailable_error.record(None);
            Ok(())
        }
        60 => {
            sample::settings_view_opened.record(None);
            Ok(())
        }
        61 => {
            sample::sub_not_validated_viewed.record(None);
            Ok(())
        }
        62 => {
            sample::subscription_blocked_viewed.record(None);
            Ok(())
        }
        63 => {
            sample::support_case_submitted.record(None);
            Ok(())
        }
        64 => {
            sample::tips_and_tricks_modal_closed.record(None);
            Ok(())
        }
        65 => {
            sample::tips_and_tricks_modal_shown.record(None);
            Ok(())
        }
        66 => {
            sample::tips_and_tricks_view_opened.record(None);
            Ok(())
        }
        67 => {
            sample::unhandled_sub_plan_interval.record(None);
            Ok(())
        }
        68 => {
            sample::update_step.record(None);
            Ok(())
        }
        69 => {
            sample::user_changed_endpoint_geo.record(None);
            Ok(())
        }
        83 => {
            interaction::about_us_selected.record(None);
            Ok(())
        }
        84 => {
            interaction::account_selected.record(None);
            Ok(())
        }
        85 => {
            interaction::add_application_selected.record(None);
            Ok(())
        }
        86 => {
            interaction::add_devices_selected.record(None);
            Ok(())
        }
        87 => {
            interaction::already_a_subscriber_selected.record(None);
            Ok(())
        }
        88 => {
            interaction::app_exclusions_selected.record(None);
            Ok(())
        }
        89 => {
            interaction::app_preferences_selected.record(None);
            Ok(())
        }
        90 => {
            interaction::approve_mozilla_vpn_selected.record(None);
            Ok(())
        }
        91 => {
            interaction::back_selected.record(None);
            Ok(())
        }
        92 => {
            interaction::block_ads_disabled.record(None);
            Ok(())
        }
        93 => {
            interaction::block_ads_enabled.record(None);
            Ok(())
        }
        94 => {
            interaction::block_malware_disabled.record(None);
            Ok(())
        }
        95 => {
            interaction::block_malware_enabled.record(None);
            Ok(())
        }
        96 => {
            interaction::block_trackers_disabled.record(None);
            Ok(())
        }
        97 => {
            interaction::block_trackers_enabled.record(None);
            Ok(())
        }
        98 => {
            interaction::cancel_selected.record(None);
            Ok(())
        }
        99 => {
            interaction::change_email_selected.record(None);
            Ok(())
        }
        100 => {
            interaction::change_plan_selected.record(None);
            Ok(())
        }
        101 => {
            interaction::clear_app_exclusions_selected.record(None);
            Ok(())
        }
        102 => {
            interaction::close_selected.record(None);
            Ok(())
        }
        103 => {
            interaction::connect_on_startup_disabled.record(None);
            Ok(())
        }
        104 => {
            interaction::connect_on_startup_enabled.record(None);
            Ok(())
        }
        105 => {
            interaction::continue_selected.record(None);
            Ok(())
        }
        106 => {
            interaction::create_account_selected.record(None);
            Ok(())
        }
        107 => {
            interaction::data_use_selected.record(None);
            Ok(())
        }
        108 => {
            interaction::dns_settings_selected.record(None);
            Ok(())
        }
        109 => {
            interaction::edit_selected.record(None);
            Ok(())
        }
        110 => {
            interaction::forgot_your_password_selected.record(None);
            Ok(())
        }
        111 => {
            interaction::get_help_selected.record(None);
            Ok(())
        }
        112 => {
            interaction::get_started_selected.record(None);
            Ok(())
        }
        113 => {
            interaction::go_back_selected.record(None);
            Ok(())
        }
        114 => {
            interaction::home_selected.record(None);
            Ok(())
        }
        115 => {
            interaction::language_selected.record(None);
            Ok(())
        }
        116 => {
            interaction::manage_subscription_selected.record(None);
            Ok(())
        }
        117 => {
            interaction::messages_selected.record(None);
            Ok(())
        }
        118 => {
            interaction::more_privacy_selected.record(None);
            Ok(())
        }
        119 => {
            interaction::my_devices_selected.record(None);
            Ok(())
        }
        120 => {
            interaction::notifications_selected.record(None);
            Ok(())
        }
        121 => {
            interaction::open_connection_info_selected.record(None);
            Ok(())
        }
        122 => {
            interaction::paste_password_selected.record(None);
            Ok(())
        }
        123 => {
            interaction::privacy_features_selected.record(None);
            Ok(())
        }
        124 => {
            interaction::privacy_notice_selected.record(None);
            Ok(())
        }
        125 => {
            interaction::refresh_selected.record(None);
            Ok(())
        }
        126 => {
            interaction::resend_code_selected.record(None);
            Ok(())
        }
        127 => {
            interaction::search_selected.record(None);
            Ok(())
        }
        128 => {
            interaction::settings_selected.record(None);
            Ok(())
        }
        129 => {
            interaction::show_android_qr_selected.record(None);
            Ok(())
        }
        130 => {
            interaction::show_ios_qr_selected.record(None);
            Ok(())
        }
        131 => {
            interaction::sign_in_selected.record(None);
            Ok(())
        }
        132 => {
            interaction::sign_out_selected.record(None);
            Ok(())
        }
        133 => {
            interaction::signup_selected.record(None);
            Ok(())
        }
        134 => {
            interaction::start_speed_test_selected.record(None);
            Ok(())
        }
        135 => {
            interaction::subscribe_now_selected.record(None);
            Ok(())
        }
        136 => {
            interaction::terms_of_service_selected.record(None);
            Ok(())
        }
        137 => {
            interaction::tips_and_tricks_selected.record(None);
            Ok(())
        }
        138 => {
            interaction::verify_selected.record(None);
            Ok(())
        }
        139 => {
            interaction::vpn_on_startup_disabled.record(None);
            Ok(())
        }
        140 => {
            interaction::vpn_on_startup_enabled.record(None);
            Ok(())
        }
        141 => {
            impression::account_screen.record(None);
            Ok(())
        }
        142 => {
            impression::app_exclusions_screen.record(None);
            Ok(())
        }
        143 => {
            impression::app_preferences_screen.record(None);
            Ok(())
        }
        144 => {
            impression::confirming_subscription_screen.record(None);
            Ok(())
        }
        145 => {
            impression::connect_on_startup_screen.record(None);
            Ok(())
        }
        146 => {
            impression::connection_info_screen.record(None);
            Ok(())
        }
        147 => {
            impression::continue_in_browser_screen.record(None);
            Ok(())
        }
        148 => {
            impression::create_password_screen.record(None);
            Ok(())
        }
        149 => {
            impression::data_collection_screen.record(None);
            Ok(())
        }
        150 => {
            impression::dns_settings_screen.record(None);
            Ok(())
        }
        151 => {
            impression::enter_email_screen.record(None);
            Ok(())
        }
        152 => {
            impression::enter_password_screen.record(None);
            Ok(())
        }
        153 => {
            impression::enter_security_code_screen.record(None);
            Ok(())
        }
        154 => {
            impression::enter_unblock_code_screen.record(None);
            Ok(())
        }
        155 => {
            impression::enter_verification_code_screen.record(None);
            Ok(())
        }
        156 => {
            impression::get_more_privacy_screen.record(None);
            Ok(())
        }
        157 => {
            impression::install_on_5_devices_screen.record(None);
            Ok(())
        }
        158 => {
            impression::language_screen.record(None);
            Ok(())
        }
        159 => {
            impression::main_screen.record(None);
            Ok(())
        }
        160 => {
            impression::network_permissions_screen.record(None);
            Ok(())
        }
        161 => {
            impression::settings_screen.record(None);
            Ok(())
        }
        162 => {
            impression::signup_screen.record(None);
            Ok(())
        }
        163 => {
            impression::speed_test_completed_screen.record(None);
            Ok(())
        }
        164 => {
            impression::speed_test_error_screen.record(None);
            Ok(())
        }
        165 => {
            impression::speed_test_loading_screen.record(None);
            Ok(())
        }
        166 => {
            impression::subscription_needed_screen.record(None);
            Ok(())
        }
        167 => {
            outcome::login_ended.record(None);
            Ok(())
        }
        168 => {
            outcome::login_started.record(None);
            Ok(())
        }
        169 => {
            outcome::onboarding_completed.record(None);
            Ok(())
        }
        170 => {
            outcome::onboarding_ntwrk_perm_denied.record(None);
            Ok(())
        }
        171 => {
            outcome::onboarding_ntwrk_perm_granted.record(None);
            Ok(())
        }
        172 => {
            outcome::onboarding_started.record(None);
            Ok(())
        }
        173 => {
            outcome::registration_completed.record(None);
            Ok(())
        }
        174 => {
            outcome::registration_started.record(None);
            Ok(())
        }
        175 => {
            outcome::speed_test_completed.record(None);
            Ok(())
        }
        176 => {
            outcome::subscription_completed.record(None);
            Ok(())
        }
        177 => {
            outcome::subscription_started.record(None);
            Ok(())
        }
        178 => {
            outcome::two_fa_verification_failed.record(None);
            Ok(())
        }
        179 => {
            outcome::two_fa_verification_succeeded.record(None);
            Ok(())
        }
        _ => Err(EventRecordingError::InvalidId),
    }
}

/// Wrapper to get the currently stored events for event metric.
///
/// # Arguments
///
/// * `metric_id` - The metric's ID to look up
/// * `ping_name` - (Optional) The ping name to look into.
///                 Defaults to the first value in `send_in_pings`.
///
/// # Returns
///
/// Returns the recorded events or `None` if nothing stored.
///
/// # Panics
///
/// Panics if no event by the given metric ID could be found.
pub(crate) fn event_test_get_value(metric_id: u32, ping_name: Option<String>) -> Option<Vec<RecordedEvent>> {
    match metric_id {
        2 => sample::addon_cta_clicked.test_get_value(ping_name.as_deref()),
        3 => sample::addon_message_state_changed.test_get_value(ping_name.as_deref()),
        4 => sample::addon_state_changed.test_get_value(ping_name.as_deref()),
        5 => sample::android_daemon_status.test_get_value(ping_name.as_deref()),
        6 => sample::app_permissions_view_opened.test_get_value(ping_name.as_deref()),
        7 => sample::app_step.test_get_value(ping_name.as_deref()),
        8 => sample::authentication_aborted.test_get_value(ping_name.as_deref()),
        9 => sample::authentication_acnt_del_step.test_get_value(ping_name.as_deref()),
        10 => sample::authentication_completed.test_get_value(ping_name.as_deref()),
        11 => sample::authentication_error.test_get_value(ping_name.as_deref()),
        12 => sample::authentication_failure.test_get_value(ping_name.as_deref()),
        13 => sample::authentication_failure_by_geo.test_get_value(ping_name.as_deref()),
        14 => sample::authentication_inapp_error.test_get_value(ping_name.as_deref()),
        15 => sample::authentication_inapp_step.test_get_value(ping_name.as_deref()),
        16 => sample::authentication_started.test_get_value(ping_name.as_deref()),
        17 => sample::authentication_sub_manage_step.test_get_value(ping_name.as_deref()),
        18 => sample::backend_failure_viewed.test_get_value(ping_name.as_deref()),
        19 => sample::billing_not_available_viewed.test_get_value(ping_name.as_deref()),
        20 => sample::bottom_navigation_bar_click.test_get_value(ping_name.as_deref()),
        21 => sample::connection_health_no_signal.test_get_value(ping_name.as_deref()),
        22 => sample::connection_health_unstable.test_get_value(ping_name.as_deref()),
        23 => sample::connectivity_handshake_timeout.test_get_value(ping_name.as_deref()),
        24 => sample::connectivity_stable.test_get_value(ping_name.as_deref()),
        25 => sample::controller_state_off.test_get_value(ping_name.as_deref()),
        26 => sample::controller_state_on.test_get_value(ping_name.as_deref()),
        27 => sample::controller_step.test_get_value(ping_name.as_deref()),
        28 => sample::delete_account_clicked.test_get_value(ping_name.as_deref()),
        29 => sample::delete_account_requested.test_get_value(ping_name.as_deref()),
        30 => sample::dns_settings_view_opened.test_get_value(ping_name.as_deref()),
        31 => sample::error_alert_shown.test_get_value(ping_name.as_deref()),
        32 => sample::get_help_clicked_initialize.test_get_value(ping_name.as_deref()),
        33 => sample::guide_closed.test_get_value(ping_name.as_deref()),
        34 => sample::guide_opened.test_get_value(ping_name.as_deref()),
        35 => sample::help_contact_support_opened.test_get_value(ping_name.as_deref()),
        36 => sample::help_menu_help_center_opened.test_get_value(ping_name.as_deref()),
        37 => sample::help_menu_view_logs_opened.test_get_value(ping_name.as_deref()),
        38 => sample::iap_g_billing_not_available.test_get_value(ping_name.as_deref()),
        39 => sample::iap_g_launchbillingflow_failed.test_get_value(ping_name.as_deref()),
        40 => sample::iap_g_no_sku_details.test_get_value(ping_name.as_deref()),
        41 => sample::iap_g_purchase_ack_failed.test_get_value(ping_name.as_deref()),
        42 => sample::iap_g_purchases_update_is_null.test_get_value(ping_name.as_deref()),
        43 => sample::iap_g_purchases_updated_failed.test_get_value(ping_name.as_deref()),
        44 => sample::iap_g_query_purchases_failed.test_get_value(ping_name.as_deref()),
        45 => sample::iap_g_query_sku_details_failed.test_get_value(ping_name.as_deref()),
        46 => sample::iap_g_sku_without_month.test_get_value(ping_name.as_deref()),
        47 => sample::iap_g_unexpected_purchasestate.test_get_value(ping_name.as_deref()),
        48 => sample::iap_restore_sub_started.test_get_value(ping_name.as_deref()),
        49 => sample::iap_subscription_completed.test_get_value(ping_name.as_deref()),
        50 => sample::iap_subscription_failed.test_get_value(ping_name.as_deref()),
        51 => sample::iap_subscription_started.test_get_value(ping_name.as_deref()),
        52 => sample::manage_account_clicked.test_get_value(ping_name.as_deref()),
        53 => sample::max_device_reached.test_get_value(ping_name.as_deref()),
        54 => sample::non_default_language_used.test_get_value(ping_name.as_deref()),
        55 => sample::notifications_view_opened.test_get_value(ping_name.as_deref()),
        56 => sample::onboarding_cta_click.test_get_value(ping_name.as_deref()),
        57 => sample::profile_flow_state_changed.test_get_value(ping_name.as_deref()),
        58 => sample::push_message_received.test_get_value(ping_name.as_deref()),
        59 => sample::server_unavailable_error.test_get_value(ping_name.as_deref()),
        60 => sample::settings_view_opened.test_get_value(ping_name.as_deref()),
        61 => sample::sub_not_validated_viewed.test_get_value(ping_name.as_deref()),
        62 => sample::subscription_blocked_viewed.test_get_value(ping_name.as_deref()),
        63 => sample::support_case_submitted.test_get_value(ping_name.as_deref()),
        64 => sample::tips_and_tricks_modal_closed.test_get_value(ping_name.as_deref()),
        65 => sample::tips_and_tricks_modal_shown.test_get_value(ping_name.as_deref()),
        66 => sample::tips_and_tricks_view_opened.test_get_value(ping_name.as_deref()),
        67 => sample::unhandled_sub_plan_interval.test_get_value(ping_name.as_deref()),
        68 => sample::update_step.test_get_value(ping_name.as_deref()),
        69 => sample::user_changed_endpoint_geo.test_get_value(ping_name.as_deref()),
        83 => interaction::about_us_selected.test_get_value(ping_name.as_deref()),
        84 => interaction::account_selected.test_get_value(ping_name.as_deref()),
        85 => interaction::add_application_selected.test_get_value(ping_name.as_deref()),
        86 => interaction::add_devices_selected.test_get_value(ping_name.as_deref()),
        87 => interaction::already_a_subscriber_selected.test_get_value(ping_name.as_deref()),
        88 => interaction::app_exclusions_selected.test_get_value(ping_name.as_deref()),
        89 => interaction::app_preferences_selected.test_get_value(ping_name.as_deref()),
        90 => interaction::approve_mozilla_vpn_selected.test_get_value(ping_name.as_deref()),
        91 => interaction::back_selected.test_get_value(ping_name.as_deref()),
        92 => interaction::block_ads_disabled.test_get_value(ping_name.as_deref()),
        93 => interaction::block_ads_enabled.test_get_value(ping_name.as_deref()),
        94 => interaction::block_malware_disabled.test_get_value(ping_name.as_deref()),
        95 => interaction::block_malware_enabled.test_get_value(ping_name.as_deref()),
        96 => interaction::block_trackers_disabled.test_get_value(ping_name.as_deref()),
        97 => interaction::block_trackers_enabled.test_get_value(ping_name.as_deref()),
        98 => interaction::cancel_selected.test_get_value(ping_name.as_deref()),
        99 => interaction::change_email_selected.test_get_value(ping_name.as_deref()),
        100 => interaction::change_plan_selected.test_get_value(ping_name.as_deref()),
        101 => interaction::clear_app_exclusions_selected.test_get_value(ping_name.as_deref()),
        102 => interaction::close_selected.test_get_value(ping_name.as_deref()),
        103 => interaction::connect_on_startup_disabled.test_get_value(ping_name.as_deref()),
        104 => interaction::connect_on_startup_enabled.test_get_value(ping_name.as_deref()),
        105 => interaction::continue_selected.test_get_value(ping_name.as_deref()),
        106 => interaction::create_account_selected.test_get_value(ping_name.as_deref()),
        107 => interaction::data_use_selected.test_get_value(ping_name.as_deref()),
        108 => interaction::dns_settings_selected.test_get_value(ping_name.as_deref()),
        109 => interaction::edit_selected.test_get_value(ping_name.as_deref()),
        110 => interaction::forgot_your_password_selected.test_get_value(ping_name.as_deref()),
        111 => interaction::get_help_selected.test_get_value(ping_name.as_deref()),
        112 => interaction::get_started_selected.test_get_value(ping_name.as_deref()),
        113 => interaction::go_back_selected.test_get_value(ping_name.as_deref()),
        114 => interaction::home_selected.test_get_value(ping_name.as_deref()),
        115 => interaction::language_selected.test_get_value(ping_name.as_deref()),
        116 => interaction::manage_subscription_selected.test_get_value(ping_name.as_deref()),
        117 => interaction::messages_selected.test_get_value(ping_name.as_deref()),
        118 => interaction::more_privacy_selected.test_get_value(ping_name.as_deref()),
        119 => interaction::my_devices_selected.test_get_value(ping_name.as_deref()),
        120 => interaction::notifications_selected.test_get_value(ping_name.as_deref()),
        121 => interaction::open_connection_info_selected.test_get_value(ping_name.as_deref()),
        122 => interaction::paste_password_selected.test_get_value(ping_name.as_deref()),
        123 => interaction::privacy_features_selected.test_get_value(ping_name.as_deref()),
        124 => interaction::privacy_notice_selected.test_get_value(ping_name.as_deref()),
        125 => interaction::refresh_selected.test_get_value(ping_name.as_deref()),
        126 => interaction::resend_code_selected.test_get_value(ping_name.as_deref()),
        127 => interaction::search_selected.test_get_value(ping_name.as_deref()),
        128 => interaction::settings_selected.test_get_value(ping_name.as_deref()),
        129 => interaction::show_android_qr_selected.test_get_value(ping_name.as_deref()),
        130 => interaction::show_ios_qr_selected.test_get_value(ping_name.as_deref()),
        131 => interaction::sign_in_selected.test_get_value(ping_name.as_deref()),
        132 => interaction::sign_out_selected.test_get_value(ping_name.as_deref()),
        133 => interaction::signup_selected.test_get_value(ping_name.as_deref()),
        134 => interaction::start_speed_test_selected.test_get_value(ping_name.as_deref()),
        135 => interaction::subscribe_now_selected.test_get_value(ping_name.as_deref()),
        136 => interaction::terms_of_service_selected.test_get_value(ping_name.as_deref()),
        137 => interaction::tips_and_tricks_selected.test_get_value(ping_name.as_deref()),
        138 => interaction::verify_selected.test_get_value(ping_name.as_deref()),
        139 => interaction::vpn_on_startup_disabled.test_get_value(ping_name.as_deref()),
        140 => interaction::vpn_on_startup_enabled.test_get_value(ping_name.as_deref()),
        141 => impression::account_screen.test_get_value(ping_name.as_deref()),
        142 => impression::app_exclusions_screen.test_get_value(ping_name.as_deref()),
        143 => impression::app_preferences_screen.test_get_value(ping_name.as_deref()),
        144 => impression::confirming_subscription_screen.test_get_value(ping_name.as_deref()),
        145 => impression::connect_on_startup_screen.test_get_value(ping_name.as_deref()),
        146 => impression::connection_info_screen.test_get_value(ping_name.as_deref()),
        147 => impression::continue_in_browser_screen.test_get_value(ping_name.as_deref()),
        148 => impression::create_password_screen.test_get_value(ping_name.as_deref()),
        149 => impression::data_collection_screen.test_get_value(ping_name.as_deref()),
        150 => impression::dns_settings_screen.test_get_value(ping_name.as_deref()),
        151 => impression::enter_email_screen.test_get_value(ping_name.as_deref()),
        152 => impression::enter_password_screen.test_get_value(ping_name.as_deref()),
        153 => impression::enter_security_code_screen.test_get_value(ping_name.as_deref()),
        154 => impression::enter_unblock_code_screen.test_get_value(ping_name.as_deref()),
        155 => impression::enter_verification_code_screen.test_get_value(ping_name.as_deref()),
        156 => impression::get_more_privacy_screen.test_get_value(ping_name.as_deref()),
        157 => impression::install_on_5_devices_screen.test_get_value(ping_name.as_deref()),
        158 => impression::language_screen.test_get_value(ping_name.as_deref()),
        159 => impression::main_screen.test_get_value(ping_name.as_deref()),
        160 => impression::network_permissions_screen.test_get_value(ping_name.as_deref()),
        161 => impression::settings_screen.test_get_value(ping_name.as_deref()),
        162 => impression::signup_screen.test_get_value(ping_name.as_deref()),
        163 => impression::speed_test_completed_screen.test_get_value(ping_name.as_deref()),
        164 => impression::speed_test_error_screen.test_get_value(ping_name.as_deref()),
        165 => impression::speed_test_loading_screen.test_get_value(ping_name.as_deref()),
        166 => impression::subscription_needed_screen.test_get_value(ping_name.as_deref()),
        167 => outcome::login_ended.test_get_value(ping_name.as_deref()),
        168 => outcome::login_started.test_get_value(ping_name.as_deref()),
        169 => outcome::onboarding_completed.test_get_value(ping_name.as_deref()),
        170 => outcome::onboarding_ntwrk_perm_denied.test_get_value(ping_name.as_deref()),
        171 => outcome::onboarding_ntwrk_perm_granted.test_get_value(ping_name.as_deref()),
        172 => outcome::onboarding_started.test_get_value(ping_name.as_deref()),
        173 => outcome::registration_completed.test_get_value(ping_name.as_deref()),
        174 => outcome::registration_started.test_get_value(ping_name.as_deref()),
        175 => outcome::speed_test_completed.test_get_value(ping_name.as_deref()),
        176 => outcome::subscription_completed.test_get_value(ping_name.as_deref()),
        177 => outcome::subscription_started.test_get_value(ping_name.as_deref()),
        178 => outcome::two_fa_verification_failed.test_get_value(ping_name.as_deref()),
        179 => outcome::two_fa_verification_succeeded.test_get_value(ping_name.as_deref()),
        _ => panic!("No event for metric id {}", metric_id),
    }
}


/// Check the provided event for errors.
///
/// # Arguments
///
/// * `metric_id` - The metric's ID to look up
/// * `error_type` - The error to we want to get the count of.
///
/// # Returns
///
/// Returns the number of recorded errors of the requested type.
///
/// # Panics
///
/// Panics if no event by the given metric ID could be found.
#[allow(unused_variables)]
pub(crate) fn event_test_get_num_recorded_errors(metric_id: u32, error_type: glean_core::ErrorType) -> i32 {
    match metric_id {
        2 => sample::addon_cta_clicked.test_get_num_recorded_errors(error_type),
        3 => sample::addon_message_state_changed.test_get_num_recorded_errors(error_type),
        4 => sample::addon_state_changed.test_get_num_recorded_errors(error_type),
        5 => sample::android_daemon_status.test_get_num_recorded_errors(error_type),
        6 => sample::app_permissions_view_opened.test_get_num_recorded_errors(error_type),
        7 => sample::app_step.test_get_num_recorded_errors(error_type),
        8 => sample::authentication_aborted.test_get_num_recorded_errors(error_type),
        9 => sample::authentication_acnt_del_step.test_get_num_recorded_errors(error_type),
        10 => sample::authentication_completed.test_get_num_recorded_errors(error_type),
        11 => sample::authentication_error.test_get_num_recorded_errors(error_type),
        12 => sample::authentication_failure.test_get_num_recorded_errors(error_type),
        13 => sample::authentication_failure_by_geo.test_get_num_recorded_errors(error_type),
        14 => sample::authentication_inapp_error.test_get_num_recorded_errors(error_type),
        15 => sample::authentication_inapp_step.test_get_num_recorded_errors(error_type),
        16 => sample::authentication_started.test_get_num_recorded_errors(error_type),
        17 => sample::authentication_sub_manage_step.test_get_num_recorded_errors(error_type),
        18 => sample::backend_failure_viewed.test_get_num_recorded_errors(error_type),
        19 => sample::billing_not_available_viewed.test_get_num_recorded_errors(error_type),
        20 => sample::bottom_navigation_bar_click.test_get_num_recorded_errors(error_type),
        21 => sample::connection_health_no_signal.test_get_num_recorded_errors(error_type),
        22 => sample::connection_health_unstable.test_get_num_recorded_errors(error_type),
        23 => sample::connectivity_handshake_timeout.test_get_num_recorded_errors(error_type),
        24 => sample::connectivity_stable.test_get_num_recorded_errors(error_type),
        25 => sample::controller_state_off.test_get_num_recorded_errors(error_type),
        26 => sample::controller_state_on.test_get_num_recorded_errors(error_type),
        27 => sample::controller_step.test_get_num_recorded_errors(error_type),
        28 => sample::delete_account_clicked.test_get_num_recorded_errors(error_type),
        29 => sample::delete_account_requested.test_get_num_recorded_errors(error_type),
        30 => sample::dns_settings_view_opened.test_get_num_recorded_errors(error_type),
        31 => sample::error_alert_shown.test_get_num_recorded_errors(error_type),
        32 => sample::get_help_clicked_initialize.test_get_num_recorded_errors(error_type),
        33 => sample::guide_closed.test_get_num_recorded_errors(error_type),
        34 => sample::guide_opened.test_get_num_recorded_errors(error_type),
        35 => sample::help_contact_support_opened.test_get_num_recorded_errors(error_type),
        36 => sample::help_menu_help_center_opened.test_get_num_recorded_errors(error_type),
        37 => sample::help_menu_view_logs_opened.test_get_num_recorded_errors(error_type),
        38 => sample::iap_g_billing_not_available.test_get_num_recorded_errors(error_type),
        39 => sample::iap_g_launchbillingflow_failed.test_get_num_recorded_errors(error_type),
        40 => sample::iap_g_no_sku_details.test_get_num_recorded_errors(error_type),
        41 => sample::iap_g_purchase_ack_failed.test_get_num_recorded_errors(error_type),
        42 => sample::iap_g_purchases_update_is_null.test_get_num_recorded_errors(error_type),
        43 => sample::iap_g_purchases_updated_failed.test_get_num_recorded_errors(error_type),
        44 => sample::iap_g_query_purchases_failed.test_get_num_recorded_errors(error_type),
        45 => sample::iap_g_query_sku_details_failed.test_get_num_recorded_errors(error_type),
        46 => sample::iap_g_sku_without_month.test_get_num_recorded_errors(error_type),
        47 => sample::iap_g_unexpected_purchasestate.test_get_num_recorded_errors(error_type),
        48 => sample::iap_restore_sub_started.test_get_num_recorded_errors(error_type),
        49 => sample::iap_subscription_completed.test_get_num_recorded_errors(error_type),
        50 => sample::iap_subscription_failed.test_get_num_recorded_errors(error_type),
        51 => sample::iap_subscription_started.test_get_num_recorded_errors(error_type),
        52 => sample::manage_account_clicked.test_get_num_recorded_errors(error_type),
        53 => sample::max_device_reached.test_get_num_recorded_errors(error_type),
        54 => sample::non_default_language_used.test_get_num_recorded_errors(error_type),
        55 => sample::notifications_view_opened.test_get_num_recorded_errors(error_type),
        56 => sample::onboarding_cta_click.test_get_num_recorded_errors(error_type),
        57 => sample::profile_flow_state_changed.test_get_num_recorded_errors(error_type),
        58 => sample::push_message_received.test_get_num_recorded_errors(error_type),
        59 => sample::server_unavailable_error.test_get_num_recorded_errors(error_type),
        60 => sample::settings_view_opened.test_get_num_recorded_errors(error_type),
        61 => sample::sub_not_validated_viewed.test_get_num_recorded_errors(error_type),
        62 => sample::subscription_blocked_viewed.test_get_num_recorded_errors(error_type),
        63 => sample::support_case_submitted.test_get_num_recorded_errors(error_type),
        64 => sample::tips_and_tricks_modal_closed.test_get_num_recorded_errors(error_type),
        65 => sample::tips_and_tricks_modal_shown.test_get_num_recorded_errors(error_type),
        66 => sample::tips_and_tricks_view_opened.test_get_num_recorded_errors(error_type),
        67 => sample::unhandled_sub_plan_interval.test_get_num_recorded_errors(error_type),
        68 => sample::update_step.test_get_num_recorded_errors(error_type),
        69 => sample::user_changed_endpoint_geo.test_get_num_recorded_errors(error_type),
        83 => interaction::about_us_selected.test_get_num_recorded_errors(error_type),
        84 => interaction::account_selected.test_get_num_recorded_errors(error_type),
        85 => interaction::add_application_selected.test_get_num_recorded_errors(error_type),
        86 => interaction::add_devices_selected.test_get_num_recorded_errors(error_type),
        87 => interaction::already_a_subscriber_selected.test_get_num_recorded_errors(error_type),
        88 => interaction::app_exclusions_selected.test_get_num_recorded_errors(error_type),
        89 => interaction::app_preferences_selected.test_get_num_recorded_errors(error_type),
        90 => interaction::approve_mozilla_vpn_selected.test_get_num_recorded_errors(error_type),
        91 => interaction::back_selected.test_get_num_recorded_errors(error_type),
        92 => interaction::block_ads_disabled.test_get_num_recorded_errors(error_type),
        93 => interaction::block_ads_enabled.test_get_num_recorded_errors(error_type),
        94 => interaction::block_malware_disabled.test_get_num_recorded_errors(error_type),
        95 => interaction::block_malware_enabled.test_get_num_recorded_errors(error_type),
        96 => interaction::block_trackers_disabled.test_get_num_recorded_errors(error_type),
        97 => interaction::block_trackers_enabled.test_get_num_recorded_errors(error_type),
        98 => interaction::cancel_selected.test_get_num_recorded_errors(error_type),
        99 => interaction::change_email_selected.test_get_num_recorded_errors(error_type),
        100 => interaction::change_plan_selected.test_get_num_recorded_errors(error_type),
        101 => interaction::clear_app_exclusions_selected.test_get_num_recorded_errors(error_type),
        102 => interaction::close_selected.test_get_num_recorded_errors(error_type),
        103 => interaction::connect_on_startup_disabled.test_get_num_recorded_errors(error_type),
        104 => interaction::connect_on_startup_enabled.test_get_num_recorded_errors(error_type),
        105 => interaction::continue_selected.test_get_num_recorded_errors(error_type),
        106 => interaction::create_account_selected.test_get_num_recorded_errors(error_type),
        107 => interaction::data_use_selected.test_get_num_recorded_errors(error_type),
        108 => interaction::dns_settings_selected.test_get_num_recorded_errors(error_type),
        109 => interaction::edit_selected.test_get_num_recorded_errors(error_type),
        110 => interaction::forgot_your_password_selected.test_get_num_recorded_errors(error_type),
        111 => interaction::get_help_selected.test_get_num_recorded_errors(error_type),
        112 => interaction::get_started_selected.test_get_num_recorded_errors(error_type),
        113 => interaction::go_back_selected.test_get_num_recorded_errors(error_type),
        114 => interaction::home_selected.test_get_num_recorded_errors(error_type),
        115 => interaction::language_selected.test_get_num_recorded_errors(error_type),
        116 => interaction::manage_subscription_selected.test_get_num_recorded_errors(error_type),
        117 => interaction::messages_selected.test_get_num_recorded_errors(error_type),
        118 => interaction::more_privacy_selected.test_get_num_recorded_errors(error_type),
        119 => interaction::my_devices_selected.test_get_num_recorded_errors(error_type),
        120 => interaction::notifications_selected.test_get_num_recorded_errors(error_type),
        121 => interaction::open_connection_info_selected.test_get_num_recorded_errors(error_type),
        122 => interaction::paste_password_selected.test_get_num_recorded_errors(error_type),
        123 => interaction::privacy_features_selected.test_get_num_recorded_errors(error_type),
        124 => interaction::privacy_notice_selected.test_get_num_recorded_errors(error_type),
        125 => interaction::refresh_selected.test_get_num_recorded_errors(error_type),
        126 => interaction::resend_code_selected.test_get_num_recorded_errors(error_type),
        127 => interaction::search_selected.test_get_num_recorded_errors(error_type),
        128 => interaction::settings_selected.test_get_num_recorded_errors(error_type),
        129 => interaction::show_android_qr_selected.test_get_num_recorded_errors(error_type),
        130 => interaction::show_ios_qr_selected.test_get_num_recorded_errors(error_type),
        131 => interaction::sign_in_selected.test_get_num_recorded_errors(error_type),
        132 => interaction::sign_out_selected.test_get_num_recorded_errors(error_type),
        133 => interaction::signup_selected.test_get_num_recorded_errors(error_type),
        134 => interaction::start_speed_test_selected.test_get_num_recorded_errors(error_type),
        135 => interaction::subscribe_now_selected.test_get_num_recorded_errors(error_type),
        136 => interaction::terms_of_service_selected.test_get_num_recorded_errors(error_type),
        137 => interaction::tips_and_tricks_selected.test_get_num_recorded_errors(error_type),
        138 => interaction::verify_selected.test_get_num_recorded_errors(error_type),
        139 => interaction::vpn_on_startup_disabled.test_get_num_recorded_errors(error_type),
        140 => interaction::vpn_on_startup_enabled.test_get_num_recorded_errors(error_type),
        141 => impression::account_screen.test_get_num_recorded_errors(error_type),
        142 => impression::app_exclusions_screen.test_get_num_recorded_errors(error_type),
        143 => impression::app_preferences_screen.test_get_num_recorded_errors(error_type),
        144 => impression::confirming_subscription_screen.test_get_num_recorded_errors(error_type),
        145 => impression::connect_on_startup_screen.test_get_num_recorded_errors(error_type),
        146 => impression::connection_info_screen.test_get_num_recorded_errors(error_type),
        147 => impression::continue_in_browser_screen.test_get_num_recorded_errors(error_type),
        148 => impression::create_password_screen.test_get_num_recorded_errors(error_type),
        149 => impression::data_collection_screen.test_get_num_recorded_errors(error_type),
        150 => impression::dns_settings_screen.test_get_num_recorded_errors(error_type),
        151 => impression::enter_email_screen.test_get_num_recorded_errors(error_type),
        152 => impression::enter_password_screen.test_get_num_recorded_errors(error_type),
        153 => impression::enter_security_code_screen.test_get_num_recorded_errors(error_type),
        154 => impression::enter_unblock_code_screen.test_get_num_recorded_errors(error_type),
        155 => impression::enter_verification_code_screen.test_get_num_recorded_errors(error_type),
        156 => impression::get_more_privacy_screen.test_get_num_recorded_errors(error_type),
        157 => impression::install_on_5_devices_screen.test_get_num_recorded_errors(error_type),
        158 => impression::language_screen.test_get_num_recorded_errors(error_type),
        159 => impression::main_screen.test_get_num_recorded_errors(error_type),
        160 => impression::network_permissions_screen.test_get_num_recorded_errors(error_type),
        161 => impression::settings_screen.test_get_num_recorded_errors(error_type),
        162 => impression::signup_screen.test_get_num_recorded_errors(error_type),
        163 => impression::speed_test_completed_screen.test_get_num_recorded_errors(error_type),
        164 => impression::speed_test_error_screen.test_get_num_recorded_errors(error_type),
        165 => impression::speed_test_loading_screen.test_get_num_recorded_errors(error_type),
        166 => impression::subscription_needed_screen.test_get_num_recorded_errors(error_type),
        167 => outcome::login_ended.test_get_num_recorded_errors(error_type),
        168 => outcome::login_started.test_get_num_recorded_errors(error_type),
        169 => outcome::onboarding_completed.test_get_num_recorded_errors(error_type),
        170 => outcome::onboarding_ntwrk_perm_denied.test_get_num_recorded_errors(error_type),
        171 => outcome::onboarding_ntwrk_perm_granted.test_get_num_recorded_errors(error_type),
        172 => outcome::onboarding_started.test_get_num_recorded_errors(error_type),
        173 => outcome::registration_completed.test_get_num_recorded_errors(error_type),
        174 => outcome::registration_started.test_get_num_recorded_errors(error_type),
        175 => outcome::speed_test_completed.test_get_num_recorded_errors(error_type),
        176 => outcome::subscription_completed.test_get_num_recorded_errors(error_type),
        177 => outcome::subscription_started.test_get_num_recorded_errors(error_type),
        178 => outcome::two_fa_verification_failed.test_get_num_recorded_errors(error_type),
        179 => outcome::two_fa_verification_succeeded.test_get_num_recorded_errors(error_type),
        _ => panic!("No event for metric id {}", metric_id),
    }
}
